Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## jet.server.api.admin
Interface SecurityAdminService

    public interface SecurityAdminService

Interface `SecurityAdminService` provides methods to manage security resource in report server.

Since:
  5.0

Method Summary
`java.lang.String` | `addAcl(java.lang.String realmName, java.lang.String aclName, java.lang.String submitter)` Deprecated. This method is not effective since V6.
`java.lang.String` | `addGroup(java.lang.String realmName, java.lang.String groupName, java.lang.String description, java.lang.String submitter)` Adds a new group into the realm.
`java.lang.String` | `addGroupIntoRole(java.lang.String realmName, java.lang.String submitter, java.lang.String groupName, java.lang.String roleName)` Adds a group to a role as a member.
`java.lang.String` | `addMemberIntoAcl(java.lang.String realmName, java.lang.String aclName, java.lang.String memberName, java.lang.String submitter)` Deprecated. This method is not effective since V6.
`java.lang.String` | `addMemberIntoGroup(java.lang.String realmName, java.lang.String groupName, java.lang.String memberName, java.lang.String submitter)` Deprecated. This method is not effective since V6.
`java.lang.String` | `addNewParentRolesToUser(java.lang.String realmName, java.lang.String submitter, java.lang.String userName, java.lang.String roleName)` Adds some new parent roles to a user.
`java.lang.String` | `addPrivilegedGroups(java.lang.String realmName, java.lang.String submitter, java.lang.String privilege, java.util.Vector groups)` Adds roles to have this privilege.
`java.lang.String` | `addPrivilegedRoles(java.lang.String realmName, java.lang.String submitter, java.lang.String privilege, java.util.Vector roles)` Adds roles to have this privilege.
`void` | `addPrivilegedRoles(java.lang.String privilege, java.util.Vector roles)` Deprecated. Server V7.1 replaced by `addPrivilegedRoles(String realmName, String submitter, String privilege, Vector groups) throws NoSuchGroupException, NoSuchRealmException, BadRealmException;`.
`java.lang.String` | `addPrivilegedUsers(java.lang.String realmName, java.lang.String submitter, java.lang.String privilege, java.util.Vector users)` Adds users to have this privilege.
`void` | `addPrivilegedUsers(java.lang.String privilege, java.util.Vector users)` Deprecated. Server V7.1 replaced by `addPrivilegedUsers(String realmName, String submitter, String privilege, Vector users) throws NoSuchUserException, NoSuchRealmException;`.
`java.lang.String` | `addProtection(java.lang.String realmName, java.lang.String resourcePath, java.lang.String aclName, java.lang.String submitter)` Deprecated. This method is not effective since V6.
`java.lang.String` | `addRealm(java.lang.String realmName, java.lang.String submitter, int scheme)` Adds a new realm specified by realmName.
`java.lang.String` | `addRole(java.lang.String realmName, java.lang.String roleName, java.lang.String description, java.lang.String submitter)` Adds a new role into the realm.
`java.lang.String` | `addRole(java.lang.String realmName, java.lang.String roleName, java.lang.String description, java.lang.String parentRoleName, java.lang.String submitter)` Deprecated. This method is not effective since V7.0 .
`java.lang.String` | `addSubGroupIntoGroup(java.lang.String realmName, java.lang.String submitter, java.lang.String subGroupName, java.lang.String groupName)` Adds a group into a group as sub group.
`java.lang.String` | `addSubRoleToRole(java.lang.String realmName, java.lang.String submitter, java.lang.String subRoleName, java.lang.String roleName)` Adds a sub role to a role.
`java.lang.String` | `addSubUserToRole(java.lang.String realmName, java.lang.String submitter, java.lang.String subUserName, java.lang.String roleName)` Adds a sub user to a role.
`java.lang.String` | `addUser(java.lang.String realmName, java.lang.String userName, java.lang.String password, java.lang.String fullName, java.lang.String description, java.lang.String email, boolean passNeverExpire, int passExpireTime, boolean passPermitBlank, int passMinLength, boolean disabledAccount, java.lang.String submitter)` Deprecated. This method is not effective since V6.
`java.lang.String` | `addUser(java.lang.String realmName, java.lang.String submitter, java.lang.String userName, java.lang.String password, java.lang.String fullName, java.lang.String description, java.lang.String email, boolean passNeverExpire, int passExpireTime, boolean passPermitBlank, int passMinLength, boolean disabledAccount)` Adds a new user into the realm.
`java.lang.String` | `addUserIntoGroup(java.lang.String realmName, java.lang.String submitter, java.lang.String userName, java.lang.String groupName)` Adds a user into a group as sub user
`java.lang.String` | `addUserIntoRole(java.lang.String realmName, java.lang.String roleName, java.lang.String userName, java.lang.String submitter)` Adds a user into a role.
`java.lang.String` | `changePassword(java.lang.String realmName, java.lang.String userName, java.lang.String subPwd, java.lang.String newPwd, java.lang.String submitter)` Changes user password.
`java.lang.String` | `editLDAPUser(java.lang.String realmName, java.lang.String userName, java.lang.String fullName, java.lang.String description, java.lang.String email, java.lang.String submitter)` Edits the specified user.
`java.lang.String` | `editProtection(java.lang.String realmName, java.lang.String resourcePath, java.lang.String aclName, java.lang.String submitter)` Deprecated. This method is not effective since V6.
`java.lang.String` | `editUser(java.lang.String realmName, java.lang.String userName, java.lang.String fullName, java.lang.String description, java.lang.String email, boolean passNeverExpire, int passExpireTime, boolean passPermitBlank, int passMinLength, boolean disabledAccount, java.lang.String submitter)` Edits the specified user.
`java.security.acl.Acl` | `getAcl(java.lang.String realmName, java.lang.String aclName)` Deprecated. This method is not effective since V6.
`java.util.Enumeration` | `getAclNames(java.lang.String realmName)` Deprecated. This method is not effective since V6.
`java.util.Enumeration` | `getAcls(java.lang.String realmName)` Deprecated. This method is not effective since V6.
`java.lang.String` | `getActiveRealm()` Gets the active Realm in JReport server.
`java.util.Enumeration` | `getAllGroupNames(java.lang.String realmName)` Gets all group name list in the realm.
`java.util.Enumeration` | `getAllGroups(java.lang.String realmName)` Deprecated. This method is not effective since Server V6.0
`java.util.Vector` | `getAllGroups(java.lang.String realmName, java.lang.String submitter)` Deprecated. This method is not effective since Server V7.1. It is replaced by the method getAllJGroups();
`JGroup[]` | `getAllJGroups(java.lang.String realmName, java.lang.String submitter)` Returns a JGroup array that contains all groups in the server
`JRole[]` | `getAllJRoles(java.lang.String realmName, java.lang.String submitter)` Gets all roles set in the realm.
`JUser[]` | `getAllJUser(java.lang.String realmName, java.lang.String submitter)` Gets all users set in the realm.
`java.util.Enumeration` | `getAllRealmNames()` Gets all realm name list in report server.
`java.util.Vector` | `getAllRoleNames(java.lang.String realmName, java.lang.String submitter)` Gets all role name list in the realm.
`java.util.Vector` | `getAllRoles(java.lang.String realmName, java.lang.String submitter)` Deprecated. This method is not effective since Server V8, replaced by the method getAllJRoles().
`java.util.Vector` | `getAllUser(java.lang.String realmName, java.lang.String submitter)` Deprecated. This method is not effective since Server V8, replaced by the method getJUser().
`java.util.Enumeration` | `getAllUserNames(java.lang.String realmName)` Gets all user name list in the realm.
`java.util.Enumeration` | `getAllUserNames(java.lang.String realmName, java.lang.String groupName)` Deprecated. This method is not effective since Server V6.0
`java.util.Enumeration` | `getAllUserNamesByRole(java.lang.String submitter, java.lang.String realmName, java.lang.String roleName)` Gets all user name list in the role.
`java.lang.String` | `getCombinedAclName(java.lang.String realmName, java.lang.String resourcePath)` Deprecated. This method is not effective since V6.
`java.lang.String` | `getCurRealm()` Gets the current editing Realm in JReport server.
`java.security.acl.Group` | `getGroup(java.lang.String realmName, java.lang.String groupName)` Deprecated. This method is not effective since Server V6.0
`jet.server.intf.security.Group` | `getGroupByName(java.lang.String realmName, java.lang.String submitter, java.lang.String groupName)` Deprecated. This method is not effective since Server V7.1
`int` | `getGroupMemberCount(java.lang.String realmName, java.lang.String groupName)` Gets the number of members in a group.
`int` | `getGroupMemberCount(java.lang.String realmName, java.lang.String submitter, java.lang.String groupName)` Gets the number of members in a group.
`java.util.Vector` | `getGroupPrivileges(java.lang.String realmName, java.lang.String submitter, java.lang.String groupName)` Gets a group's privileges.
`java.util.Vector` | `getGroupsByRole(java.lang.String realmName, java.lang.String submitter, java.lang.String roleName)` Deprecated. This method is not effective since Server V8, replaced by the method getJGroupsByJRole().
`java.util.Vector` | `getGroupsByUser(java.lang.String realmName, java.lang.String submitter, java.lang.String userName)` Deprecated. This method is not effective since Server V8, replaced by the method getJGroupsByJUser().
`JGroup` | `getJGroupByName(java.lang.String realmName, java.lang.String submitter, java.lang.String groupName)` Gets a group specified by group name
`JGroup[]` | `getJGroupsByJRole(java.lang.String realmName, java.lang.String submitter, java.lang.String roleName)` Gets sub groups from the role.
`JGroup[]` | `getJGroupsByJUser(java.lang.String realmName, java.lang.String submitter, java.lang.String userName)` Gets the groups which the specific user has.
`JRole` | `getJRole(java.lang.String submitter, java.lang.String realmName, java.lang.String roleName)` Gets a role specified by roleName.
`JRole[]` | `getJRolesByJGroup(java.lang.String realmName, java.lang.String submitter, java.lang.String groupName)` Gets parent roles' object from the group.
`JUser` | `getJUser(java.lang.String submitter, java.lang.String realmName, java.lang.String userName)` Gets a user.
`JUser[]` | `getJUsersByJGroup(java.lang.String realmName, java.lang.String submitter, java.lang.String groupName)` Gets sub user object array from the parent group.
`boolean` | `getMessageMode()` Gets the internal message mode in JReport server.
`JRole[]` | `getParentJRolesByJUser(java.lang.String realmName, java.lang.String submitter, java.lang.String userName)` Gets the roles which the specific user has.
`java.util.Vector` | `getParentRolesByUser(java.lang.String realmName, java.lang.String submitter, java.lang.String userName)` Deprecated. This method is not effective since Server V8, replaced by the method getParentJRolesByJUser().
`java.util.Vector` | `getPrivilegedGroups(java.lang.String realmName, java.lang.String submitter, java.lang.String privilege)` Gets all groups who have the privilege.
`java.util.Vector` | `getPrivilegedRoles(java.lang.String privilege)` Deprecated. Server V7.1 replaced by `getPrivilegedRoles(String realmName, String submitter, String privilege,) throws NoSuchRealmException;`.
`java.util.Vector` | `getPrivilegedRoles(java.lang.String realmName, java.lang.String submitter, java.lang.String privilege)` Gets all roles who have the privilege.
`java.util.Vector` | `getPrivilegedUsers(java.lang.String privilege)` Deprecated. Server V7.1 replaced by `getPrivilegedUsers(String realmName, String submitter, String privilege,) throws NoSuchRealmException;`.
`java.util.Vector` | `getPrivilegedUsers(java.lang.String realmName, java.lang.String submitter, java.lang.String privilege)` Gets all users who have the privilege.
`java.util.Hashtable[]` | `getPrivileges(java.lang.String realmName, java.lang.String submitter)` Gets defined privileges of users.
`java.util.Enumeration` | `getProtections(java.lang.String realmName)` Deprecated. This method is not effective since V6.
`java.util.Vector` | `getReferRoles(java.lang.String realmName, java.lang.String userName)` Deprecated. This method is not effective since Server V8, replaced by the method getReferJRolers().
`java.util.Vector` | `getReferUsers(java.lang.String realmName, java.lang.String userName)` Deprecated. This method is not effective since Server V8, replaced by the method getReferJUsers().
`jet.server.intf.security.Role` | `getRole(java.lang.String submitter, java.lang.String realmName, java.lang.String roleName)` Deprecated. This method is not effective since Server V8, replaced by the method getJRole().
`int` | `getRoleMemberCount(java.lang.String realmName, java.lang.String roleName)` Gets member count in a role.
`int` | `getRoleMemberCount(java.lang.String realmName, java.lang.String submitter, java.lang.String roleName)` Gets member count in a role.
`java.util.Vector` | `getRolePrivileges(java.lang.String roleName)` Deprecated. Server V7.1 replaced by `getRolePrivileges(String realmName, String submitter, String roleName,) throws NoSuchRoleException, NoSuchRealmException;`.
`java.util.Vector` | `getRolePrivileges(java.lang.String realmName, java.lang.String submitter, java.lang.String roleName)` Gets a role's privileges.
`java.util.Vector` | `getRolesByGroup(java.lang.String realmName, java.lang.String submitter, java.lang.String groupName)` Deprecated. This method is not effective since Server V8, replaced by the method getJRolesByJGroup().
`java.util.Vector` | `getSubGroupsByGroup(java.lang.String realmName, java.lang.String submitter, java.lang.String groupName)` Deprecated. This method is not effective since Server V8, replaced by the method getJUsersByJGroup().
`JGroup[]` | `getSubJGroupsByJGroup(java.lang.String realmName, java.lang.String submitter, java.lang.String groupName)` Gets sub groups from the parent group.
`JRole[]` | `getSubJRolesByJRole(java.lang.String realmName, java.lang.String submitter, java.lang.String roleName)` Gets the set of a role's sub roles.
`JUser[]` | `getSubJUsersByJRole(java.lang.String realmName, java.lang.String submitter, java.lang.String roleName)` Gets the set of a role's sub users.
`java.util.Vector` | `getSubRolesByRole(java.lang.String realmName, java.lang.String submitter, java.lang.String roleName)` Deprecated. This method is not effective since Server V8, replaced by the method getSubJRolesByJRole().
`java.util.Vector` | `getSubUsersByRole(java.lang.String realmName, java.lang.String submitter, java.lang.String roleName)` Deprecated. This method is not effective since Server V8, replaced by the method getSubJUsersByJRole().
`java.util.Vector` | `getSubUsersNameByRole(java.lang.String realmName, java.lang.String submitter, java.lang.String roleName)` Deprecated. This method is not effective since Server V8, replaced by the method getSubJUsersNameByJRole().
`jet.server.intf.security.User` | `getUser(java.lang.String submitter, java.lang.String realmName, java.lang.String userName)` Deprecated. This method is not effective since Server V8, replaced by the method getJUser().
`java.lang.String` | `getUserDescription(java.lang.String realmName, java.lang.String userName)` Gets a user's description.
`java.lang.String` | `getUserEmail(java.lang.String realmName, java.lang.String userName)` Gets a user's email address.
`java.lang.String` | `getUserFullname(java.lang.String realmName, java.lang.String userName)` Gets a user's full name.
`int` | `getUserParentGroupsCount(java.lang.String realmName, java.lang.String userName)` Gets the count of a user's parent groups.
`int` | `getUserParentRolesCount(java.lang.String realmName, java.lang.String userName)` Gets the count if a user's parent roles' count.
`int` | `getUserPasswordExpireTime(java.lang.String realmName, java.lang.String userName)` Gets user password expirated time
`int` | `getUserPasswordMinLength(java.lang.String realmName, java.lang.String userName)` Gets user password minimum length.
`java.util.Vector` | `getUserPrivileges(java.lang.String userName)` Deprecated. Server V7.1 replaced by `getUserPrivileges(String realmName, String submitter, String userName,) throws NoSuchUserException, NoSuchRealmException;`.
`java.util.Vector` | `getUserPrivileges(java.lang.String realmName, java.lang.String submitter, java.lang.String userName)` Gets a user's privileges.
`java.util.Vector` | `getUsersByGroup(java.lang.String realmName, java.lang.String submitter, java.lang.String groupName)` Deprecated. This method is not effective since Server V8, replaced by the method getJUsersByJGroup().
`boolean` | `isAdminUser(java.lang.String userName)` Checks if the user is administrator.
`boolean` | `isAuditFileAccessFail(java.lang.String realmName, java.lang.String userName)` Checks if to audit failed ACCESS event for the user.
`boolean` | `isAuditFileAccessSuccess(java.lang.String realmName, java.lang.String userName)` Checks if to audit successful ACCESS event for the user.
`boolean` | `isAuditManageFail(java.lang.String realmName, java.lang.String userName)` Checks if to audit failed MANAGE event for the user.
`boolean` | `isAuditManageSuccess(java.lang.String realmName, java.lang.String userName)` Checks if to audit successful MANAGE event for the user.
`boolean` | `isEditing(java.lang.String realm, int action)` Checks if the action can be edited.
`boolean` | `isJGroupInJGroup(java.lang.String realmName, java.lang.String submitter, java.lang.String groupName, java.lang.String parentName)` Indicates whether the group is in a parent group.
`boolean` | `isJGroupInJRole(java.lang.String realmName, java.lang.String submitter, java.lang.String groupName, java.lang.String roleName)` Indicates whether the group is in a role.
`boolean` | `isJRoleInJRole(java.lang.String realmName, java.lang.String submitter, java.lang.String roleName, java.lang.String parentName)` Indicates whether the role is in a parent role.
`boolean` | `isJUserInJGroup(java.lang.String realmName, java.lang.String submitter, java.lang.String userName, java.lang.String groupName)` Indicates whether the user is in a group.
`boolean` | `isJUserInJRole(java.lang.String realmName, java.lang.String submitter, java.lang.String userName, java.lang.String roleName)` Indicates whether the user is in a role.
`boolean` | `isNoAudit(java.lang.String realmName, java.lang.String userName)` Checks if not to audit any ACCESS or MANAGE event for the user.
`boolean` | `isOrganizationAdminUser(java.lang.String userName)` Checks if the user is administrator of a organization.
`boolean` | `isUserAccountDisable(java.lang.String realmName, java.lang.String userName)` Checks whether a user account is disabled.
`boolean` | `isUserPasswordNeverExpire(java.lang.String realmName, java.lang.String userName)` Checks if user password never expires.
`boolean` | `isUserPasswordPermitBlank(java.lang.String realmName, java.lang.String userName)` Checks if user password permits blank.
`java.lang.String` | `removeAcl(java.lang.String realmName, java.lang.String aclName, java.lang.String submitter)` Deprecated. This method is not effective since V6.
`java.lang.String` | `removeGroup(java.lang.String realmName, java.lang.String groupName, java.lang.String submitter)` Removes a group from the realm.
`java.lang.String` | `removeGroupFromRole(java.lang.String realmName, java.lang.String submitter, java.lang.String groupName, java.lang.String roleName)` Remove a group from the role.
`java.lang.String` | `removeMemberFromAcl(java.lang.String realmName, java.lang.String aclName, java.lang.String memberName, java.lang.String submitter)` Deprecated. This method is not effective since V6.
`java.lang.String` | `removeMemberFromGroup(java.lang.String realmName, java.lang.String groupName, java.lang.String memberName, java.lang.String submitter)` Deprecated. This method is not effective since V6.
`java.lang.String` | `removeParentRolesFromUser(java.lang.String realmName, java.lang.String submitter, java.lang.String userName, java.lang.String roleName)` Removes a parent role from a user.
`java.lang.String` | `removePrivilegedGroups(java.lang.String realmName, java.lang.String submitter, java.lang.String privilege, java.util.Vector groups)` Removes groups from having the privilege.
`java.lang.String` | `removePrivilegedRoles(java.lang.String realmName, java.lang.String submitter, java.lang.String privilege, java.util.Vector roles)` Removes roles from having the privilege.
`java.lang.String` | `removePrivilegedRoles(java.lang.String privilege, java.util.Vector roles)` Deprecated. Server V7.1 replaced by `removePrivilegedRoles(String realmName, String submitter, String privilege, Vector roles) throws NoSuchRoleException, NoSuchRealmException;`.
`java.lang.String` | `removePrivilegedUsers(java.lang.String realmName, java.lang.String submitter, java.lang.String privilege, java.util.Vector users)` Removes users from having the privilege.
`java.lang.String` | `removePrivilegedUsers(java.lang.String privilege, java.util.Vector users)` Deprecated. Server V7.1 replaced by `removePrivilegedUsers(String realmName, String submitter, String privilege, Vector users) throws NoSuchUserException, NoSuchRealmException;`.
`java.lang.String` | `removeProtection(java.lang.String realmName, java.lang.String resourcePath, java.lang.String submitter)` Deprecated. This method is not effective since V6.
`java.lang.String` | `removeRealm(java.lang.String realmName, java.lang.String submitter)` Removes a realm specified by realmName.
`java.lang.String` | `removeRole(java.lang.String realmName, java.lang.String roleName, java.lang.String submitter)` Removes a role from the realm.
`java.lang.String` | `removeRoleFromParentRole(java.lang.String submitter, java.lang.String realmName, java.lang.String roleName, java.lang.String parentRoleName)` Removes a role from a parent role.
`java.lang.String` | `removeSubGroupFromGroup(java.lang.String realmName, java.lang.String submitter, java.lang.String subGroupName, java.lang.String groupName)` Removes a sub group from the group.
`java.lang.String` | `removeUser(java.lang.String realmName, java.lang.String userName, java.lang.String submitter)` Removes a user from the realm.
`java.lang.String` | `removeUserFromGroup(java.lang.String realmName, java.lang.String submitter, java.lang.String userName, java.lang.String groupName)` Removes a user from the group.
`java.lang.String` | `removeUserFromParentRole(java.lang.String submitter, java.lang.String realmName, java.lang.String userName, java.lang.String parentRoleName)` Removes a user from a parent role.
`java.lang.String` | `removeUserFromRole(java.lang.String realmName, java.lang.String roleName, java.lang.String userName, java.lang.String submitter)` Deprecated. This method is not effective since Server V7.0
`java.lang.String` | `setAuditFileAccessFail(java.lang.String realmName, java.lang.String userName, boolean b, java.lang.String submitter)` Sets whether to audit failed ACCESS actions for the user.
`java.lang.String` | `setAuditFileAccessSuccess(java.lang.String realmName, java.lang.String userName, boolean b, java.lang.String submitter)` Sets whether to audit successful ACCESS actions for the user.
`java.lang.String` | `setAuditManageFail(java.lang.String realmName, java.lang.String userName, boolean b, java.lang.String submitter)` Sets whether to audit failed MANAGE actions for the user.
`java.lang.String` | `setAuditManageSuccess(java.lang.String realmName, java.lang.String userName, boolean b, java.lang.String submitter)` Sets whether to audit successful MANAGE actions for the user.
`void` | `setCurRealm(java.lang.String realm)` Sets the current editing Realm in JReport server.
`java.lang.String` | `setGroupPrivileges(java.lang.String realmName, java.lang.String submitter, java.lang.String groupName, java.util.Vector privileges)` Sets privileges to a group.
`java.lang.String` | `setMemberPermissions(java.lang.String realmName, java.lang.String aclName, java.lang.String memberName, java.util.Vector permissions, boolean isNegative, java.lang.String submitter)` Deprecated. This method is not effective since V6.
`void` | `setMessageMode(boolean mode)` Sets the internal message mode in JReport server.
`java.lang.String` | `setNoAudit(java.lang.String realmName, java.lang.String userName, boolean b, java.lang.String submitter)` Sets whether no event to be audited for the user.
`void` | `setPrivileges(java.lang.String realmName, java.lang.String submitter, java.util.Hashtable[] privileges)` Sets privileges of users.
`java.lang.String` | `setRolePrivileges(java.lang.String realmName, java.lang.String submitter, java.lang.String roleName, java.util.Vector privileges)` Sets privileges to a role.
`void` | `setRolePrivileges(java.lang.String roleName, java.util.Vector privileges)` Deprecated. Server V7.1 replaced by `setRolePrivileges(String realmName, String submitter, String roleName, Vector privileges) throws NoSuchRoleException, NoSuchRealmException;`.
`java.lang.String` | `setUserPrivileges(java.lang.String realmName, java.lang.String submitter, java.lang.String userName, java.util.Vector privileges)` Sets privileges to a user.
`void` | `setUserPrivileges(java.lang.String userName, java.util.Vector privileges)` Deprecated. Server V7.1 replaced by `setUserPrivileges(String realmName, String submitter, String userName, Vector privileges) throws NoSuchUserException, NoSuchRealmException;`.

Method Detail

### getCurRealm

    java.lang.String getCurRealm()

  Gets the current editing Realm in JReport server.

### setCurRealm

    void setCurRealm(java.lang.String realm)

  Sets the current editing Realm in JReport server.

### getMessageMode

    boolean getMessageMode()

  Gets the internal message mode in JReport server. true---returns message string. false---returns message key.

### setMessageMode

    void setMessageMode(boolean mode)

  Sets the internal message mode in JReport server.

### getActiveRealm

    java.lang.String getActiveRealm()

  Gets the active Realm in JReport server.

### getAllRealmNames

    java.util.Enumeration getAllRealmNames()

  Gets all realm name list in report server.

  Returns:
    the enumeration represent all realm name list.
  Since:

### addRealm

    java.lang.String addRealm(java.lang.String realmName,
                              java.lang.String submitter,
                              int scheme)
                              throws NoSuchRealmException,
                                     BadRealmException,
                                     NoSuchAclException,
                                     java.security.acl.NotOwnerException,
                                     NoSuchUserException,
                                     InUseException

  Adds a new realm specified by realmName.

  Parameters:
    `realmName` - the new realm name
    `submitter` - the user who requested this action.
    `scheme` - Realm authentication scheme, 0: basic authentication, 1: digest authentication
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchAclException` - if acl does not exist.
    `java.security.acl.NotOwnerException` - if the Principal attempting the modification is not an owner.
    `NoSuchUserException` - if the user does not exist.
    `InUseException` - if attempting to delete an object, such as a user or group, which is in use as part of the realm's security policy.
  Since:

### removeRealm

    java.lang.String removeRealm(java.lang.String realmName,
                                 java.lang.String submitter)

  Removes a realm specified by realmName.

  Parameters:
    `realmName` - the new realm name
    `submitter` - the user who requested this action.
  Returns:
    error message if any error occurs, or null if successful.
  Since:

### addGroup

    java.lang.String addGroup(java.lang.String realmName,
                              java.lang.String groupName,
                              java.lang.String description,
                              java.lang.String submitter)
                              throws NoSuchRealmException,
                                     BadRealmException,
                                     NoSuchGroupException,
                                     InUseException,
                                     java.io.IOException

  Adds a new group into the realm.

  Parameters:
    `realmName` - the realm name
    `groupName` - the new group name
    `description` - the new group description
    `submitter` - the user who requested this action
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchGroupException` - if the group does not exist.
    `InUseException` - if attempting to delete an object, such as a user or group, which is in use as part of the realm's security policy.
    `java.io.IOException` - if error occurs when trying to save data.
  Since:
    server V7.1

### removeGroup

    java.lang.String removeGroup(java.lang.String realmName,
                                 java.lang.String groupName,
                                 java.lang.String submitter)
                                 throws NoSuchRealmException,
                                        BadRealmException,
                                        NoSuchGroupException,
                                        InUseException

  Removes a group from the realm.

  Parameters:
    `realmName` - the realm name.
    `groupName` - the new group name.
    `submitter` - the user who requested this action.
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchGroupException` - if the group does not exist.
    `InUseException` - if attempting to delete an object, such as a user or group, which is in use as part of the realm's security policy.
  Since:
    server V7.1

### getAllGroups

    java.util.Enumeration getAllGroups(java.lang.String realmName)
                                       throws NoSuchRealmException,
                                              BadRealmException

  Deprecated. This method is not effective since Server V6.0

  Gets all group list in the realm.

  Parameters:
    `realmName` - the realm name.
  Returns:
    the enumeration representing all group list.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.

### getAllGroups

    java.util.Vector getAllGroups(java.lang.String realmName,
                                  java.lang.String submitter)
                                  throws NoSuchRealmException,
                                         BadRealmException

  Deprecated. This method is not effective since Server V7.1. It is replaced by the method getAllJGroups();

  Gets all group list in the realm.

  Parameters:
    `realmName` - the realm name.
    `submitter` - the user who requested this action.
  Returns:
    the vector representing all group list.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
  Since:
    Server V7.1

### getAllJGroups

    JGroup[] getAllJGroups(java.lang.String realmName,
                           java.lang.String submitter)
                           throws NoSuchRealmException,
                                  BadRealmException

  Returns a JGroup array that contains all groups in the server

  Parameters:
    `realmName` - the realm name.
    `submitter` - the user who requested this action.
  Returns:
    the array representing all group list.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
  Since:
    Server V8
  See Also:
    `JGroup`

### getAllGroupNames

    java.util.Enumeration getAllGroupNames(java.lang.String realmName)
                                           throws NoSuchRealmException,
                                                  BadRealmException

  Gets all group name list in the realm.

  Parameters:
    `realmName` - the realm name.
  Returns:
    the enumeration representing all group name list.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
  Since:
    server V7.1

### getGroup

    java.security.acl.Group getGroup(java.lang.String realmName,
                                     java.lang.String groupName)
                                     throws NoSuchRealmException,
                                            BadRealmException,
                                            NoSuchGroupException

  Deprecated. This method is not effective since Server V6.0

  Gets a group specified by groupName.

  Parameters:
    `realmName` - the realm name.
    `groupName` - the group name.
  Returns:
    a Group that is requested.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchGroupException` - if the group does not exist.
  Since:

### getGroupByName

    jet.server.intf.security.Group getGroupByName(java.lang.String realmName,
                                                  java.lang.String submitter,
                                                  java.lang.String groupName)
                                                  throws NoSuchRealmException,
                                                         BadRealmException,
                                                         NoSuchGroupException

  Deprecated. This method is not effective since Server V7.1

  Gets a group specified by group name

  Parameters:
    `realmName` - the realm name
    `submitter` - the user who requested this action.
    `groupName` - the group name
  Returns:
    a Group that is requested.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchGroupException` - if the group does not exist.
  Since:
    server V7.1

### getJGroupByName

    JGroup getJGroupByName(java.lang.String realmName,
                           java.lang.String submitter,
                           java.lang.String groupName)
                           throws NoSuchRealmException,
                                  BadRealmException,
                                  NoSuchGroupException

  Gets a group specified by group name

  Parameters:
    `realmName` - the realm name
    `submitter` - the user who requested this action.
    `groupName` - the group name
  Returns:
    a Group that is requested, return `null` if `submitter` is not an administrator user.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchGroupException` - if the group does not exist.
  Since:
    server V8
  See Also:
    `JGroup`

### getGroupMemberCount

    int getGroupMemberCount(java.lang.String realmName,
                            java.lang.String groupName)
                            throws NoSuchRealmException,
                                   BadRealmException,
                                   NoSuchGroupException

  Gets the number of members in a group.

  Parameters:
    `realmName` - the realm name.
    `groupName` - the group name.
  Returns:
    the member count in the specified group.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchGroupException` - if the group does not exist.
  Since:
    server 7.1

### getGroupMemberCount

    int getGroupMemberCount(java.lang.String realmName,
                            java.lang.String submitter,
                            java.lang.String groupName)
                            throws NoSuchRealmException,
                                   BadRealmException,
                                   NoSuchGroupException

  Gets the number of members in a group.

  Parameters:
    `realmName` - the realm name.
    `submitter` - the user who requested this action.
    `groupName` - the group name.
  Returns:
    the member count in the specified group.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchGroupException` - if the group does not exist.
  Since:
    server 7.1

### addUserIntoGroup

    java.lang.String addUserIntoGroup(java.lang.String realmName,
                                      java.lang.String submitter,
                                      java.lang.String userName,
                                      java.lang.String groupName)
                                      throws NoSuchRealmException,
                                             BadRealmException,
                                             NoSuchGroupException,
                                             NoSuchUserException

  Adds a user into a group as sub user

  Parameters:
    `realmName` - the realm name
    `submitter` - the user who requested this action.
    `userName` - the user name
    `groupName` - the group name
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchGroupException` - if the group does not exist.
    `NoSuchUserException` - if the user does not exist.
  Since:
    ServerV7.1

### addSubGroupIntoGroup

    java.lang.String addSubGroupIntoGroup(java.lang.String realmName,
                                          java.lang.String submitter,
                                          java.lang.String subGroupName,
                                          java.lang.String groupName)
                                          throws NoSuchRealmException,
                                                 BadRealmException,
                                                 NoSuchGroupException

  Adds a group into a group as sub group.

  Parameters:
    `realmName` - the realm name
    `submitter` - the user who requested this action.
    `subGroupName` - the sub group name
    `groupName` - the group name
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchGroupException` - if the group does not exist.
  Since:
    ServerV7.1

### addGroupIntoRole

    java.lang.String addGroupIntoRole(java.lang.String realmName,
                                      java.lang.String submitter,
                                      java.lang.String groupName,
                                      java.lang.String roleName)
                                      throws NoSuchRealmException,
                                             BadRealmException,
                                             NoSuchGroupException,
                                             NoSuchRoleException

  Adds a group to a role as a member.

  Parameters:
    `realmName` - the realm name
    `submitter` - the user who requested this action.
    `groupName` - the group name
    `roleName` - the role name
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchGroupException` - if the group does not exist.
    `NoSuchRoleException` - if the role does not exist.
  Since:
    ServerV7.1

### removeUserFromGroup

    java.lang.String removeUserFromGroup(java.lang.String realmName,
                                         java.lang.String submitter,
                                         java.lang.String userName,
                                         java.lang.String groupName)
                                         throws NoSuchRealmException,
                                                BadRealmException,
                                                NoSuchGroupException,
                                                NoSuchUserException

  Removes a user from the group.

  Parameters:
    `realmName` - the realm name
    `submitter` - the user who requested this action.
    `userName` - the user name
    `groupName` - the group name
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchGroupException` - if the group does not exist.
    `NoSuchUserException` - if the user does not exist.
  Since:
    ServerV7.1

### removeSubGroupFromGroup

    java.lang.String removeSubGroupFromGroup(java.lang.String realmName,
                                             java.lang.String submitter,
                                             java.lang.String subGroupName,
                                             java.lang.String groupName)
                                             throws NoSuchRealmException,
                                                    BadRealmException,
                                                    NoSuchGroupException

  Removes a sub group from the group.

  Parameters:
    `realmName` - the realm name
    `submitter` - the user who requested this action.
    `subGroupName` - the sub group name
    `groupName` - the group name
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchGroupException` - if the group does not exist.
  Since:
    ServerV7.1

### removeGroupFromRole

    java.lang.String removeGroupFromRole(java.lang.String realmName,
                                         java.lang.String submitter,
                                         java.lang.String groupName,
                                         java.lang.String roleName)
                                         throws NoSuchRealmException,
                                                BadRealmException,
                                                NoSuchGroupException,
                                                NoSuchRoleException

  Remove a group from the role.

  Parameters:
    `realmName` - the realm name
    `submitter` - the user who requested this action.
    `groupName` - the group name
    `roleName` - the role name
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchGroupException` - if the group does not exist.
    `NoSuchRoleException` - if the role does not exist.
  Since:
    ServerV7.1

### getSubGroupsByGroup

    java.util.Vector getSubGroupsByGroup(java.lang.String realmName,
                                         java.lang.String submitter,
                                         java.lang.String groupName)
                                         throws NoSuchGroupException,
                                                NoSuchRealmException,
                                                BadRealmException

  Deprecated. This method is not effective since Server V8, replaced by the method getJUsersByJGroup().

  Gets sub groups from the parent group.

  Parameters:
    `realmName` - the realm name
    `submitter` - the user who requested this action.
    `groupName` - the group name
  Returns:
    a Vector saving the sub groups' names
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchGroupException` - if the group does not exist.
  Since:
    ServerV7.1

### getSubJGroupsByJGroup

    JGroup[] getSubJGroupsByJGroup(java.lang.String realmName,
                                   java.lang.String submitter,
                                   java.lang.String groupName)
                                   throws NoSuchGroupException,
                                          NoSuchRealmException,
                                          BadRealmException

  Gets sub groups from the parent group.

  Parameters:
    `realmName` - the realm name
    `submitter` - the user who requested this action.
    `groupName` - the group name
  Returns:
    a Vector saving the sub groups' names
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchGroupException` - if the group does not exist.
  Since:
    ServerV8
  See Also:
    `JGroup`

### getUsersByGroup

    java.util.Vector getUsersByGroup(java.lang.String realmName,
                                     java.lang.String submitter,
                                     java.lang.String groupName)
                                     throws NoSuchGroupException,
                                            NoSuchRealmException,
                                            BadRealmException

  Deprecated. This method is not effective since Server V8, replaced by the method getJUsersByJGroup().

  Gets users from the parent group.

  Parameters:
    `realmName` - the realm name
    `submitter` - the user who requested this action.
    `groupName` - the group name
  Returns:
    a Vector saving the sub users' names
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchGroupException` - if the group does not exist.
  Since:
    ServerV7.1

### getJUsersByJGroup

    JUser[] getJUsersByJGroup(java.lang.String realmName,
                              java.lang.String submitter,
                              java.lang.String groupName)
                              throws NoSuchGroupException,
                                     NoSuchRealmException,
                                     BadRealmException

  Gets sub user object array from the parent group.

  Parameters:
    `realmName` - the realm name
    `submitter` - the user who requested this action.
    `groupName` - the group name
  Returns:
    a Vector saving the sub users' names, return `null` if `submitter` is not an administrator user.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchGroupException` - if the group does not exist.
  Since:
    ServerV8
  See Also:
    `JUser`

### getRolesByGroup

    java.util.Vector getRolesByGroup(java.lang.String realmName,
                                     java.lang.String submitter,
                                     java.lang.String groupName)
                                     throws NoSuchGroupException,
                                            NoSuchRealmException,
                                            BadRealmException

  Deprecated. This method is not effective since Server V8, replaced by the method getJRolesByJGroup().

  Gets parent roles' names from the group.

  Parameters:
    `realmName` - the realm name
    `submitter` - the user who requested this action.
    `groupName` - the group name
  Returns:
    a Vector saving the parent roles' names
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchGroupException` - if the group does not exist.
  Since:
    ServerV7.1

### getJRolesByJGroup

    JRole[] getJRolesByJGroup(java.lang.String realmName,
                              java.lang.String submitter,
                              java.lang.String groupName)
                              throws NoSuchGroupException,
                                     NoSuchRealmException,
                                     BadRealmException

  Gets parent roles' object from the group.

  Parameters:
    `realmName` - the realm name
    `submitter` - the user who requested this action.
    `groupName` - the group name
  Returns:
    a Vector saving the parent roles' names, return `null` if `submitter` is not an administrator user.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchGroupException` - if the group does not exist.
  Since:
    ServerV8
  See Also:
    `JRole`

### getGroupsByRole

    java.util.Vector getGroupsByRole(java.lang.String realmName,
                                     java.lang.String submitter,
                                     java.lang.String roleName)
                                     throws NoSuchRoleException,
                                            NoSuchRealmException,
                                            BadRealmException

  Deprecated. This method is not effective since Server V8, replaced by the method getJGroupsByJRole().

  Gets sub groups from the role.

  Parameters:
    `realmName` - the realm name
    `submitter` - the user who requested this action.
    `roleName` - the role name
  Returns:
    a Vector saving the sub groups' names
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchRoleException` - if the role does not exist.
  Since:
    ServerV7.1

### getJGroupsByJRole

    JGroup[] getJGroupsByJRole(java.lang.String realmName,
                               java.lang.String submitter,
                               java.lang.String roleName)
                               throws NoSuchRoleException,
                                      NoSuchRealmException,
                                      BadRealmException

  Gets sub groups from the role.

  Parameters:
    `realmName` - the realm name
    `submitter` - the user who requested this action.
    `roleName` - the role name
  Returns:
    a Vector saving the sub groups' names, return `null` if `submitter` is not an administrator user.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchRoleException` - if the role does not exist.
  Since:
    ServerV8
  See Also:
    `JRole`

### getUser

    jet.server.intf.security.User getUser(java.lang.String submitter,
                                          java.lang.String realmName,
                                          java.lang.String userName)
                                          throws NoSuchUserException,
                                                 NoSuchRealmException

  Deprecated. This method is not effective since Server V8, replaced by the method getJUser().

  Gets a user.

  Parameters:
    `submitter` - the user who requested this action.
    `realmName` - the realm name
    `userName` - the user name
  Returns:
    a `User` object
  Throws:
    `NoSuchUserException` - if there is no specific user in security manager.
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
  Since:
    V6

### getJUser

    JUser getJUser(java.lang.String submitter,
                   java.lang.String realmName,
                   java.lang.String userName)
                   throws NoSuchUserException,
                          NoSuchRealmException

  Gets a user.

  Parameters:
    `submitter` - the user who requested this action.
    `realmName` - the realm name.
    `userName` - the user name
  Returns:
    a `JUser` object, return `null` if `submitter` is not an administrator user.
  Throws:
    `NoSuchUserException` - if there is no specific user in security manager.
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
  Since:
    V8
  See Also:
    `JUser`

### addUser

    java.lang.String addUser(java.lang.String realmName,
                             java.lang.String userName,
                             java.lang.String password,
                             java.lang.String fullName,
                             java.lang.String description,
                             java.lang.String email,
                             boolean passNeverExpire,
                             int passExpireTime,
                             boolean passPermitBlank,
                             int passMinLength,
                             boolean disabledAccount,
                             java.lang.String submitter)
                             throws NoSuchRealmException,
                                    BadRealmException,
                                    NoSuchUserException,
                                    InUseException,
                                    java.io.IOException

  Deprecated. This method is not effective since V6.

  Adds a new user into the realm.

  Parameters:
    `realmName` - the realm name.
    `userName` - the user name.
    `password` - the new user password.
    `fullName` - the new user full name.
    `description` - the new user description.
    `email` - the new user email.
    `passNeverExpire` - whether the password will be expired, true if it will not be expired.
    `passExpireTime` - if passNeverExpire is false, represents after how long the password will be expired.
    `passPermitBlank` - whether the password can be blank, true if blank is permitted.
    `passMinLength` - if password cannot be blank, represents the password's minimum length.
    `disabledAccount` - whether this user account can be used.
    `submitter` - the user who requested this action.
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchUserException` - if the user does not exist.
    `InUseException` - if attempting to delete an object, such as a user or group, which is in use as part of the realm's security policy.
    `java.io.IOException` - if error occurs when trying to save data.
  Since:

### addUser

    java.lang.String addUser(java.lang.String realmName,
                             java.lang.String submitter,
                             java.lang.String userName,
                             java.lang.String password,
                             java.lang.String fullName,
                             java.lang.String description,
                             java.lang.String email,
                             boolean passNeverExpire,
                             int passExpireTime,
                             boolean passPermitBlank,
                             int passMinLength,
                             boolean disabledAccount)
                             throws NoSuchRealmException,
                                    UserExistsException

  Adds a new user into the realm.

  Parameters:
    `realmName` - the realm name.
    `submitter` - the user who requested this action.
    `userName` - the user name.
    `password` - the new user password.
    `fullName` - the new user full name.
    `description` - the new user description.
    `email` - the new user email.
    `passNeverExpire` - whether the password will be expired, true if it will not be expired.
    `passExpireTime` - if passNeverExpire is false, represents after how long the password will be expired .
    `passPermitBlank` - whether the password can be blank, true if blank is permitted.
    `passMinLength` - if password cannot be blank, represents the password's minimum length.
    `disabledAccount` - whether this user account can be used.
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `UserExistsException` - if the user specified by userName exists.
    `NoSuchRealmException`
    `UserExistsException`
  Since:
    V6

### removeUser

    java.lang.String removeUser(java.lang.String realmName,
                                java.lang.String userName,
                                java.lang.String submitter)
                                throws NoSuchRealmException,
                                       BadRealmException,
                                       NoSuchUserException,
                                       InUseException

  Removes a user from the realm.

  Parameters:
    `realmName` - the realm name.
    `userName` - the user name.
    `submitter` - the user who requested this action.
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchUserException` - if the user does not exist.
    `InUseException` - if attempting to delete an object, such as a user or group, which is in use as part of the realm's security policy.
  Since:

### getUserFullname

    java.lang.String getUserFullname(java.lang.String realmName,
                                     java.lang.String userName)
                                     throws NoSuchRealmException,
                                            BadRealmException,
                                            NoSuchUserException

  Gets a user's full name.

  Parameters:
    `realmName` - the realm name.
    `userName` - the user name.
  Returns:
    the user's full name.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchUserException` - if the user does not exist.

### getUserDescription

    java.lang.String getUserDescription(java.lang.String realmName,
                                        java.lang.String userName)
                                        throws NoSuchRealmException,
                                               BadRealmException,
                                               NoSuchUserException

  Gets a user's description.

  Parameters:
    `realmName` - the realm name.
    `userName` - the user name.
  Returns:
    the user's full name.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchUserException` - if the user does not exist.

### getUserEmail

    java.lang.String getUserEmail(java.lang.String realmName,
                                  java.lang.String userName)
                                  throws NoSuchRealmException,
                                         BadRealmException,
                                         NoSuchUserException

  Gets a user's email address.

  Parameters:
    `realmName` - the realm name.
    `userName` - the user name.
  Returns:
    the user's full name.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchUserException` - if the user does not exist.

### isUserAccountDisable

    boolean isUserAccountDisable(java.lang.String realmName,
                                 java.lang.String userName)
                                 throws NoSuchRealmException,
                                        BadRealmException,
                                        NoSuchUserException

  Checks whether a user account is disabled.

  Parameters:
    `realmName` - the realm name.
    `userName` - the user name.
  Returns:
    the user's full name.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchUserException` - if the user does not exist.

### isUserPasswordNeverExpire

    boolean isUserPasswordNeverExpire(java.lang.String realmName,
                                      java.lang.String userName)
                                      throws NoSuchRealmException,
                                             BadRealmException,
                                             NoSuchUserException

  Checks if user password never expires.

  Parameters:
    `realmName` - the realm name.
    `userName` - the user name.
  Returns:
    the user's full name.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchUserException` - if the user does not exist.

### getUserPasswordExpireTime

    int getUserPasswordExpireTime(java.lang.String realmName,
                                  java.lang.String userName)
                                  throws NoSuchRealmException,
                                         BadRealmException,
                                         NoSuchUserException

  Gets user password expirated time

  Parameters:
    `realmName` - the realm name.
    `userName` - the user name.
  Returns:
    the user's full name.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchUserException` - if the user does not exist.

### isUserPasswordPermitBlank

    boolean isUserPasswordPermitBlank(java.lang.String realmName,
                                      java.lang.String userName)
                                      throws NoSuchRealmException,
                                             BadRealmException,
                                             NoSuchUserException

  Checks if user password permits blank.

  Parameters:
    `realmName` - the realm name.
    `userName` - the user name.
  Returns:
    the user's full name.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchUserException` - if the user does not exist.

### getUserPasswordMinLength

    int getUserPasswordMinLength(java.lang.String realmName,
                                 java.lang.String userName)
                                 throws NoSuchRealmException,
                                        BadRealmException,
                                        NoSuchUserException

  Gets user password minimum length.

  Parameters:
    `realmName` - the realm name.
    `userName` - the user name.
  Returns:
    the user's full name.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchUserException` - if the user does not exist.

### changePassword

    java.lang.String changePassword(java.lang.String realmName,
                                    java.lang.String userName,
                                    java.lang.String subPwd,
                                    java.lang.String newPwd,
                                    java.lang.String submitter)
                                    throws NoSuchRealmException,
                                           BadRealmException,
                                           NoSuchUserException

  Changes user password.

  Parameters:
    `realmName` - the realm name.
    `userName` - the user name.
    `subPwd` - the submitter's password
    `newPwd` - new password
    `submitter` - the user who requested this action.
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchUserException` - if the user does not exist.
  Since:

### editLDAPUser

    java.lang.String editLDAPUser(java.lang.String realmName,
                                  java.lang.String userName,
                                  java.lang.String fullName,
                                  java.lang.String description,
                                  java.lang.String email,
                                  java.lang.String submitter)
                                  throws NoSuchRealmException,
                                         BadRealmException,
                                         NoSuchUserException,
                                         InUseException,
                                         java.io.IOException

  Edits the specified user.

  Parameters:
    `realmName` - the realm name.
    `userName` - the user name.
    `fullName` - the new user full name.
    `description` - the new user description.
    `email` - the new user email.
    `submitter` - the user who requested this action.
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchUserException` - if the user does not exist.
    `InUseException` - if attempting to delete an object, such as a user or group, which is in use as part of the realm's security policy.
    `java.io.IOException` - if error occurs when trying to save data.
  Since:
    V6

### editUser

    java.lang.String editUser(java.lang.String realmName,
                              java.lang.String userName,
                              java.lang.String fullName,
                              java.lang.String description,
                              java.lang.String email,
                              boolean passNeverExpire,
                              int passExpireTime,
                              boolean passPermitBlank,
                              int passMinLength,
                              boolean disabledAccount,
                              java.lang.String submitter)
                              throws NoSuchRealmException,
                                     BadRealmException,
                                     NoSuchUserException,
                                     InUseException,
                                     java.io.IOException

  Edits the specified user.

  Parameters:
    `realmName` - the realm name.
    `userName` - the user name.
    `fullName` - the new user full name.
    `description` - the new user description.
    `email` - the new user email.
    `passNeverExpire` - whether the password will be expired, true if it will not be expired.
    `passExpireTime` - if passNeverExpire is false, represents after how long the password will be expired .
    `passPermitBlank` - whether the password can be blank, true if blank is permitted.
    `passMinLength` - if password cannot be blank, represents the password's minimum length.
    `disabledAccount` - whether this user account can be used.
    `submitter` - the user who requested this action.
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchUserException` - if the user does not exist.
    `InUseException` - if attempting to delete an object, such as a user or group, which is in use as part of the realm's security policy.
    `java.io.IOException` - if error occurs when trying to save data.
  Since:

### getAllUserNames

    java.util.Enumeration getAllUserNames(java.lang.String realmName)
                                          throws NoSuchRealmException,
                                                 BadRealmException

  Gets all user name list in the realm.

  Parameters:
    `realmName` - the realm name.
  Returns:
    the enumeration representing all user name list in the realm.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
  Since:

### getAllUser

    java.util.Vector getAllUser(java.lang.String realmName,
                                java.lang.String submitter)
                                throws NoSuchRealmException,
                                       BadRealmException

  Deprecated. This method is not effective since Server V8, replaced by the method getJUser().

  Gets all users set in the realm.

  Parameters:
    `realmName` - the realm name.
    `submitter` - the user who requested this action.
  Returns:
    the vector representing all user name list in the realm.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
  Since:
    V6

### getAllJUser

    JUser[] getAllJUser(java.lang.String realmName,
                        java.lang.String submitter)
                        throws NoSuchRealmException,
                               BadRealmException

  Gets all users set in the realm.

  Parameters:
    `realmName` - the realm name.
    `submitter` - the user who requested this action.
  Returns:
    the array representing all user name list in the realm.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
  Since:
    V8
  See Also:
    `JUser`

### getAllUserNames

    java.util.Enumeration getAllUserNames(java.lang.String realmName,
                                          java.lang.String groupName)
                                          throws NoSuchRealmException,
                                                 BadRealmException,
                                                 NoSuchGroupException

  Deprecated. This method is not effective since Server V6.0

  Gets all user name list in the group.

  Parameters:
    `realmName` - the realm name.
    `groupName` - the group name.
  Returns:
    the enumeration representing all user name list in the realm.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchGroupException` - if the group does not exist.
  Since:

### getAllUserNamesByRole

    java.util.Enumeration getAllUserNamesByRole(java.lang.String submitter,
                                                java.lang.String realmName,
                                                java.lang.String roleName)
                                                throws NoSuchRealmException,
                                                       BadRealmException,
                                                       NoSuchRoleException

  Gets all user name list in the role.

  Parameters:
    `submitter` - the user who requested this action.
    `realmName` - the realm name.
    `roleName` - the role name.
  Returns:
    the enumeration representing all user name list in the realm.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchRoleException` - if the role does not exist.
  Since:
    V6

### getParentRolesByUser

    java.util.Vector getParentRolesByUser(java.lang.String realmName,
                                          java.lang.String submitter,
                                          java.lang.String userName)
                                          throws NoSuchUserException,
                                                 NoSuchRealmException

  Deprecated. This method is not effective since Server V8, replaced by the method getParentJRolesByJUser().

  Gets the roles which the specific user has.

  Parameters:
    `realmName` - the realm name.
    `submitter` - user id who sent this request
    `userName` - the user name
  Returns:
    a `Vector` object containing the role names which the specific user has, or null if the submitter does not have permission for getting the roles of this user.
  Throws:
    `NoSuchUserException` - if the user does not exist.
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
  Since:
    V6

### getParentJRolesByJUser

    JRole[] getParentJRolesByJUser(java.lang.String realmName,
                                   java.lang.String submitter,
                                   java.lang.String userName)
                                   throws NoSuchUserException,
                                          NoSuchRealmException

  Gets the roles which the specific user has.

  Parameters:
    `realmName` - the realm name.
    `submitter` - user id who sent this request
    `userName` - the user name
  Returns:
    a `Vector` object containing the role names which the specific user has, or null if the submitter does not have permission for getting the roles of this user.
  Throws:
    `NoSuchUserException` - if the user does not exist.
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
  Since:
    V8
  See Also:
    `JRole`

### getGroupsByUser

    java.util.Vector getGroupsByUser(java.lang.String realmName,
                                     java.lang.String submitter,
                                     java.lang.String userName)
                                     throws NoSuchUserException,
                                            NoSuchRealmException

  Deprecated. This method is not effective since Server V8, replaced by the method getJGroupsByJUser().

  Gets the groups which the specific user has.

  Parameters:
    `realmName` - the realm name
    `submitter` - the user who requested this action.
    `userName` - the user name
  Returns:
    a `Vector` object containing the group names which the specific user has, or null if the submitter does not have permission for getting the groups of this user.
  Throws:
    `NoSuchUserException` - if the user does not exist
    `NoSuchRealmException` - if the realm does not exist
  Since:
    server V7.1

### getJGroupsByJUser

    JGroup[] getJGroupsByJUser(java.lang.String realmName,
                               java.lang.String submitter,
                               java.lang.String userName)
                               throws NoSuchUserException,
                                      NoSuchRealmException

  Gets the groups which the specific user has.

  Parameters:
    `realmName` - the realm name
    `submitter` - the user who requested this action.
    `userName` - the user name
  Returns:
    a `Vector` object containing the group names which the specific user has, return `null` if `submitter` is not an administrator user.
  Throws:
    `NoSuchUserException` - if the user does not exist
    `NoSuchRealmException` - if the realm does not exist
  Since:
    server V8
  See Also:
    `JGroup`

### addNewParentRolesToUser

    java.lang.String addNewParentRolesToUser(java.lang.String realmName,
                                             java.lang.String submitter,
                                             java.lang.String userName,
                                             java.lang.String roleName)
                                             throws NoSuchRoleException,
                                                    NoSuchUserException,
                                                    NoSuchRealmException

  Adds some new parent roles to a user.

  Parameters:
    `realmName` - the realm name.
    `submitter` - the submitter's name
    `userName` - the name of the user that will be added some new parent roles
    `roleName` - the new parent role's name.
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchUserException` - if the user does not exist.
    `NoSuchRoleException` - if the role does not exist.
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
  Since:
    V6

### addMemberIntoGroup

    java.lang.String addMemberIntoGroup(java.lang.String realmName,
                                        java.lang.String groupName,
                                        java.lang.String memberName,
                                        java.lang.String submitter)
                                        throws NoSuchRealmException,
                                               BadRealmException,
                                               NoSuchGroupException,
                                               NoSuchUserException,
                                               java.io.IOException

  Deprecated. This method is not effective since V6.

  Adds a member into a group, the member can be a user or a group in the same realm.

  Parameters:
    `realmName` - the realm name.
    `groupName` - the group name that a member will be added into.
    `memberName` - the member name, which can be a user name or a group name.
    `submitter` - the user who requested this action.
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchGroupException` - if the group does not exist.
    `NoSuchUserException` - if the user does not exist.
    `java.io.IOException` - if error occurs when trying to save data.
  Since:

### addUserIntoRole

    java.lang.String addUserIntoRole(java.lang.String realmName,
                                     java.lang.String roleName,
                                     java.lang.String userName,
                                     java.lang.String submitter)
                                     throws NoSuchRealmException,
                                            BadRealmException,
                                            NoSuchUserException,
                                            NoSuchRoleException

  Adds a user into a role.

  Parameters:
    `realmName` - the realm name.
    `roleName` - the role name that a member will be added into.
    `userName` - the user name.
    `submitter` - the user who requested this action.
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchRoleException` - if the role does not exist.
    `NoSuchUserException` - if the user does not exist.
  Since:
    V6

### removeMemberFromGroup

    java.lang.String removeMemberFromGroup(java.lang.String realmName,
                                           java.lang.String groupName,
                                           java.lang.String memberName,
                                           java.lang.String submitter)
                                           throws NoSuchRealmException,
                                                  BadRealmException,
                                                  NoSuchGroupException,
                                                  NoSuchUserException,
                                                  java.io.IOException

  Deprecated. This method is not effective since V6.

  Removes a member from a group.

  Parameters:
    `realmName` - the realm name.
    `groupName` - the group name.
    `memberName` - the member name, which can be a user name or a group name.
    `submitter` - the user who requested this action.
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchGroupException` - if the group does not exist.
    `NoSuchUserException` - if the user does not exist.
    `java.io.IOException` - if error occurs when trying to save data.
  Since:

### removeUserFromRole

    java.lang.String removeUserFromRole(java.lang.String realmName,
                                        java.lang.String roleName,
                                        java.lang.String userName,
                                        java.lang.String submitter)
                                        throws NoSuchRealmException,
                                               BadRealmException,
                                               NoSuchRoleException,
                                               NoSuchUserException

  Deprecated. This method is not effective since Server V7.0

  Removes a user from a role.

  Parameters:
    `realmName` - the realm name.
    `roleName` - the role name.
    `userName` - the user name.
    `submitter` - the user who requested this action.
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchRoleException` - if the role does not exist.
    `NoSuchUserException` - if the user does not exist.
  Since:
    V6

### getUserParentRolesCount

    int getUserParentRolesCount(java.lang.String realmName,
                                java.lang.String userName)
                                throws NoSuchUserException

  Gets the count if a user's parent roles' count.

  Parameters:
    `realmName` - the realm name.
    `userName` - the user's name
  Returns:
    the count of parent roles, if errors happen, it will return -1.
  Throws:
    `NoSuchUserException` - if the user does not exist.
  Since:
    V6

### getUserParentGroupsCount

    int getUserParentGroupsCount(java.lang.String realmName,
                                 java.lang.String userName)
                                 throws NoSuchRealmException,
                                        NoSuchUserException

  Gets the count of a user's parent groups.

  Parameters:
    `realmName` - the realm name
    `userName` - the user's name
  Returns:
    the count of the user's parent groups
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `NoSuchUserException` - if the user does not exist.
  Since:
    server 7.1

### removeParentRolesFromUser

    java.lang.String removeParentRolesFromUser(java.lang.String realmName,
                                               java.lang.String submitter,
                                               java.lang.String userName,
                                               java.lang.String roleName)
                                               throws NoSuchUserException,
                                                      NoSuchRoleException,
                                                      NoSuchRealmException

  Removes a parent role from a user.

  Parameters:
    `realmName` - the realm name.
    `submitter` - the user who requested this action.
    `userName` - the name of the user from whom a parent role will be deleted.
    `roleName` - the new parent role's name.
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchUserException` - if the user does not exist.
    `NoSuchRoleException` - if the role does not exist.
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
  Since:
    V6.

### addAcl

    java.lang.String addAcl(java.lang.String realmName,
                            java.lang.String aclName,
                            java.lang.String submitter)
                            throws NoSuchRealmException,
                                   BadRealmException,
                                   java.io.IOException

  Deprecated. This method is not effective since V6.

  Adds a new Acl into the realm.

  Parameters:
    `realmName` - the realm name.
    `aclName` - the new Acl name.
    `submitter` - the user who requested this action.
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `java.io.IOException` - if error occurs when trying to save data.
  Since:

### removeAcl

    java.lang.String removeAcl(java.lang.String realmName,
                               java.lang.String aclName,
                               java.lang.String submitter)
                               throws NoSuchRealmException,
                                      BadRealmException,
                                      NoSuchAclException

  Deprecated. This method is not effective since V6.

  Removes an Acl from the realm.

  Parameters:
    `realmName` - the realm name.
    `aclName` - the Acl name.
    `submitter` - the user who requested this action.
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchAclException` - if the acl does not exist.
  Since:

### addMemberIntoAcl

    java.lang.String addMemberIntoAcl(java.lang.String realmName,
                                      java.lang.String aclName,
                                      java.lang.String memberName,
                                      java.lang.String submitter)
                                      throws NoSuchRealmException,
                                             BadRealmException,
                                             NoSuchAclException,
                                             java.security.acl.NotOwnerException,
                                             java.io.IOException

  Deprecated. This method is not effective since V6.

  Adds a member into the Acl, the member can be a user or a group in the same realm.

  Parameters:
    `realmName` - the realm name.
    `aclName` - the Acl name.
    `memberName` - the member name, which can be a user name or a group name.
    `submitter` - the user who requested this action.
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchAclException` - if the acl does not exist.
    `java.security.acl.NotOwnerException` - if the Principal attempting the modification is not an owner.
    `java.io.IOException` - if error occurs when trying to save data.
  Since:

### setMemberPermissions

    java.lang.String setMemberPermissions(java.lang.String realmName,
                                          java.lang.String aclName,
                                          java.lang.String memberName,
                                          java.util.Vector permissions,
                                          boolean isNegative,
                                          java.lang.String submitter)
                                          throws NoSuchRealmException,
                                                 BadRealmException,
                                                 NoSuchAclException,
                                                 java.security.acl.NotOwnerException,
                                                 java.io.IOException

  Deprecated. This method is not effective since V6.

  Specifies the member's permissions.

  Parameters:
    `realmName` - the realm name.
    `aclName` - the Acl name.
    `memberName` - the member name, which can be a user name or a group name.
    `permissions` - the permissions set to this user. The permissions contained in Vector are defined in `jet.server.api.Permissions`.
    `isNegative` - whether the permissions are negative.
    `submitter` - the user who requested this action.
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchAclException` - if the acl does not exist.
    `java.security.acl.NotOwnerException` - if the Principal attempting the modification is not an owner.
    `java.io.IOException` - if error occurs when trying to save data.
  Since:
  See Also:
    `Permissions`

### removeMemberFromAcl

    java.lang.String removeMemberFromAcl(java.lang.String realmName,
                                         java.lang.String aclName,
                                         java.lang.String memberName,
                                         java.lang.String submitter)
                                         throws NoSuchRealmException,
                                                BadRealmException,
                                                NoSuchAclException,
                                                java.security.acl.NotOwnerException,
                                                java.io.IOException

  Deprecated. This method is not effective since V6.

  Removes a member from the Acl.

  Parameters:
    `realmName` - the realm name.
    `aclName` - the Acl name.
    `memberName` - the member name, which can be a user name or a group name.
    `submitter` - the user who requested this action.
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchAclException` - if the acl does not exist.
    `java.security.acl.NotOwnerException` - if the Principal attempting the modification is not an owner.
    `java.io.IOException` - if error occurs when trying to save data.
  Since:

### getAclNames

    java.util.Enumeration getAclNames(java.lang.String realmName)
                                      throws NoSuchRealmException,
                                             BadRealmException

  Deprecated. This method is not effective since V6.

  Gets all Acl name list in the realm.

  Parameters:
    `realmName` - the realm name.
  Returns:
    the enumeration that represents all Acl name list in the realm.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
  Since:

### getAcls

    java.util.Enumeration getAcls(java.lang.String realmName)
                                  throws NoSuchRealmException,
                                         BadRealmException

  Deprecated. This method is not effective since V6.

  Gets all Acl list in the realm.

  Parameters:
    `realmName` - the realm name.
  Returns:
    the enumeration that represents all Acl list in the realm.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
  Since:

### getAcl

    java.security.acl.Acl getAcl(java.lang.String realmName,
                                 java.lang.String aclName)
                                 throws NoSuchRealmException,
                                        BadRealmException,
                                        NoSuchAclException

  Deprecated. This method is not effective since V6.

  Gets an Acl specified by aclName.

  Parameters:
    `realmName` - the realm name.
    `aclName` - the Acl name.
  Returns:
    An Acl that is requested.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchAclException` - if the acl does not exist.
  Since:

### getProtections

    java.util.Enumeration getProtections(java.lang.String realmName)
                                         throws NoSuchRealmException,
                                                BadRealmException

  Deprecated. This method is not effective since V6.

  Gets all protections in the specified realm. A protection combines a resource node (not a virtual resource node) with an ACL, which means that the access of the resource node is controlled by that ACL.

  Parameters:
    `realmName` - the realm name.
  Returns:
    the enumeration that represents resource path name of protection list in the realm.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.

### getCombinedAclName

    java.lang.String getCombinedAclName(java.lang.String realmName,
                                        java.lang.String resourcePath)
                                        throws NoSuchRealmException,
                                               BadRealmException

  Deprecated. This method is not effective since V6.

  Gets acl name combined with the specified resource path in a protection.

  Parameters:
    `realmName` - the realm name.
    `resourcePath` - the resource node represented by path.
  Returns:
    the acl name.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.

### addProtection

    java.lang.String addProtection(java.lang.String realmName,
                                   java.lang.String resourcePath,
                                   java.lang.String aclName,
                                   java.lang.String submitter)
                                   throws NoSuchRealmException,
                                          BadRealmException,
                                          java.io.IOException

  Deprecated. This method is not effective since V6.

  Adds a protection into the realm. A protection combines a resource node (not a virtual resource node) with an ACL, which means that the access of the resource node is controlled by that ACL.

  Parameters:
    `realmName` - the realm name.
    `resourcePath` - the resource node represented by path.
    `aclName` - the Acl name.
    `submitter` - the user who requested this action.
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `java.io.IOException` - if error occurs when trying to save data.
  Since:

### removeProtection

    java.lang.String removeProtection(java.lang.String realmName,
                                      java.lang.String resourcePath,
                                      java.lang.String submitter)
                                      throws NoSuchRealmException,
                                             BadRealmException,
                                             java.io.IOException

  Deprecated. This method is not effective since V6.

  Removes a protection from the realm. A protection combines a resource node (not a virtual resource node) with an ACL, which means that the access of the resource node is controlled by that ACL.

  Parameters:
    `realmName` - the realm name.
    `resourcePath` - the resource node represented by path.
    `submitter` - the user who requested this action.
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `java.io.IOException` - if error occurs when trying to save data.
  Since:

### editProtection

    java.lang.String editProtection(java.lang.String realmName,
                                    java.lang.String resourcePath,
                                    java.lang.String aclName,
                                    java.lang.String submitter)
                                    throws NoSuchRealmException,
                                           BadRealmException,
                                           NoSuchAclException

  Deprecated. This method is not effective since V6.

  Edits a protection from the realm. A protection combines a resource node (note a virtual resource node) with an ACL, which means that the access of the resource node is controlled by that ACL.

  Parameters:
    `realmName` - the realm name.
    `resourcePath` - the resource node represented by path.
    `aclName` - the Acl name.
    `submitter` - the user who requested this action.
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchAclException` - if the ACL specified by aclName does not exist.
  Since:

### setNoAudit

    java.lang.String setNoAudit(java.lang.String realmName,
                                java.lang.String userName,
                                boolean b,
                                java.lang.String submitter)
                                throws NoSuchRealmException,
                                       BadRealmException,
                                       NoSuchUserException,
                                       java.io.IOException

  Sets whether no event to be audited for the user. These audit settings can point out whether report server logs users' MANAGE and/or ACCESS actions. If those settings are disabled (say, set to false), the actions of that user will not be logged. The audit setting takes effect when the log level in the report server's configuration is turned on. If the log level is none, then the settings will be ignored.

  Parameters:
    `realmName` - the realm name.
    `userName` - the user name.
    `b` - whether to log this user's MANAGE and ACCESS actions.
    `submitter` - the user who requested this action.
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchUserException` - if the user does not exist.
    `java.io.IOException` - if error occurs when trying to save data.
  Since:

### setAuditFileAccessSuccess

    java.lang.String setAuditFileAccessSuccess(java.lang.String realmName,
                                               java.lang.String userName,
                                               boolean b,
                                               java.lang.String submitter)
                                               throws NoSuchRealmException,
                                                      BadRealmException,
                                                      NoSuchUserException,
                                                      java.io.IOException

  Sets whether to audit successful ACCESS actions for the user.

  Parameters:
    `realmName` - the realm name.
    `userName` - the user name.
    `b` - whether to log this user's successful ACCESS actions.
    `submitter` - the user who requested this action.
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchUserException` - if the user does not exist.
    `java.io.IOException` - if error occurs when trying to save data.
  Since:

### setAuditFileAccessFail

    java.lang.String setAuditFileAccessFail(java.lang.String realmName,
                                            java.lang.String userName,
                                            boolean b,
                                            java.lang.String submitter)
                                            throws NoSuchRealmException,
                                                   BadRealmException,
                                                   NoSuchUserException,
                                                   java.io.IOException

  Sets whether to audit failed ACCESS actions for the user.

  Parameters:
    `realmName` - the realm name.
    `userName` - the user name.
    `b` - whether to log this user's failed ACCESS actions.
    `submitter` - the user who requested this action.
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchUserException` - if the user does not exist.
    `java.io.IOException` - if error occurs when trying to save data.
  Since:

### setAuditManageSuccess

    java.lang.String setAuditManageSuccess(java.lang.String realmName,
                                           java.lang.String userName,
                                           boolean b,
                                           java.lang.String submitter)
                                           throws NoSuchRealmException,
                                                  BadRealmException,
                                                  NoSuchUserException,
                                                  java.io.IOException

  Sets whether to audit successful MANAGE actions for the user.

  Parameters:
    `realmName` - the realm name.
    `userName` - the user name.
    `b` - whether to log this user's MANAGE actions.
    `submitter` - the user who requested this action.
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchUserException` - if the user does not exist.
    `java.io.IOException` - if error occurs when trying to save data.
  Since:

### setAuditManageFail

    java.lang.String setAuditManageFail(java.lang.String realmName,
                                        java.lang.String userName,
                                        boolean b,
                                        java.lang.String submitter)
                                        throws NoSuchRealmException,
                                               BadRealmException,
                                               NoSuchUserException,
                                               java.io.IOException

  Sets whether to audit failed MANAGE actions for the user.

  Parameters:
    `realmName` - the realm name.
    `userName` - the user name.
    `b` - whether to log this user's failed MANAGE actions.
    `submitter` - the user who requested this action.
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchUserException` - if the user does not exist.
    `java.io.IOException` - if error occurs when trying to save data.
  Since:

### isNoAudit

    boolean isNoAudit(java.lang.String realmName,
                      java.lang.String userName)
                      throws NoSuchRealmException,
                             BadRealmException,
                             NoSuchUserException

  Checks if not to audit any ACCESS or MANAGE event for the user.

  Parameters:
    `realmName` - the realm name.
    `userName` - the user name.
  Returns:
    true if not to audit any event, otherwise false.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchUserException` - if the user does not exist.
  Since:

### isAuditFileAccessSuccess

    boolean isAuditFileAccessSuccess(java.lang.String realmName,
                                     java.lang.String userName)
                                     throws NoSuchRealmException,
                                            BadRealmException,
                                            NoSuchUserException

  Checks if to audit successful ACCESS event for the user.

  Parameters:
    `realmName` - the realm name.
    `userName` - the user name.
  Returns:
    true if to audit successful ACCESS event, otherwise false.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchUserException` - if the user does not exist.
  Since:

### isAuditFileAccessFail

    boolean isAuditFileAccessFail(java.lang.String realmName,
                                  java.lang.String userName)
                                  throws NoSuchRealmException,
                                         BadRealmException,
                                         NoSuchUserException

  Checks if to audit failed ACCESS event for the user.

  Parameters:
    `realmName` - the realm name.
    `userName` - the user name.
  Returns:
    true if to audit failed ACCESS event, otherwise false.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchUserException` - if the user does not exist.
  Since:

### isAuditManageSuccess

    boolean isAuditManageSuccess(java.lang.String realmName,
                                 java.lang.String userName)
                                 throws NoSuchRealmException,
                                        BadRealmException,
                                        NoSuchUserException

  Checks if to audit successful MANAGE event for the user.

  Parameters:
    `realmName` - the realm name.
    `userName` - the user name.
  Returns:
    true if to audit successful MANAGE event, otherwise false.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchUserException` - if the user does not exist.
  Since:

### isAuditManageFail

    boolean isAuditManageFail(java.lang.String realmName,
                              java.lang.String userName)
                              throws NoSuchRealmException,
                                     BadRealmException,
                                     NoSuchUserException

  Checks if to audit failed MANAGE event for the user.

  Parameters:
    `realmName` - the realm name.
    `userName` - the user name.
  Returns:
    true if to audit failed MANAGE event, otherwise false.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchUserException` - if the user does not exist.
  Since:

### addRole

    java.lang.String addRole(java.lang.String realmName,
                             java.lang.String roleName,
                             java.lang.String description,
                             java.lang.String parentRoleName,
                             java.lang.String submitter)
                             throws NoSuchRealmException,
                                    BadRealmException,
                                    RoleExistsException

  Deprecated. This method is not effective since V7.0 .

  Adds a new role into the realm.

  Parameters:
    `realmName` - the realm name.
    `roleName` - the new role name.
    `description` - the new role description.
    `parentRoleName` - the role's parent role name.
    `submitter` - the user who requested this action.
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `RoleExistsException` - if the role exists.
  Since:
    V6

### addRole

    java.lang.String addRole(java.lang.String realmName,
                             java.lang.String roleName,
                             java.lang.String description,
                             java.lang.String submitter)
                             throws NoSuchRealmException,
                                    BadRealmException,
                                    RoleExistsException

  Adds a new role into the realm.

  Parameters:
    `realmName` - the realm name.
    `roleName` - the new role name.
    `description` - the new role description.
    `submitter` - the user who requested this action.
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `RoleExistsException` - if the role exists.
  Since:
    V7.0

### removeRole

    java.lang.String removeRole(java.lang.String realmName,
                                java.lang.String roleName,
                                java.lang.String submitter)
                                throws NoSuchRealmException,
                                       BadRealmException,
                                       NoSuchRoleException

  Removes a role from the realm.

  Parameters:
    `realmName` - the realm name.
    `roleName` - the new role name.
    `submitter` - the user who requested this action.
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchRoleException` - if the role does not exist.
  Since:
    V6

### getAllRoles

    java.util.Vector getAllRoles(java.lang.String realmName,
                                 java.lang.String submitter)
                                 throws NoSuchRealmException,
                                        BadRealmException

  Deprecated. This method is not effective since Server V8, replaced by the method getAllJRoles().

  Gets all roles set in the realm.

  Parameters:
    `realmName` - the realm name.
    `submitter` - the user who requested this action.
  Returns:
    the vector representing all role list.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
  Since:
    V6

### getAllJRoles

    JRole[] getAllJRoles(java.lang.String realmName,
                         java.lang.String submitter)
                         throws NoSuchRealmException,
                                BadRealmException

  Gets all roles set in the realm.

  Parameters:
    `realmName` - the realm name.
    `submitter` - the user who requested this action.
  Returns:
    the array representing all role list.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
  Since:
    V8
  See Also:
    `JRole`

### getAllRoleNames

    java.util.Vector getAllRoleNames(java.lang.String realmName,
                                     java.lang.String submitter)
                                     throws NoSuchRealmException,
                                            BadRealmException

  Gets all role name list in the realm.

  Parameters:
    `realmName` - the realm name.
    `submitter` - the user who requested this action.
  Returns:
    the vector representing all group name list.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
  Since:
    V6

### getRole

    jet.server.intf.security.Role getRole(java.lang.String submitter,
                                          java.lang.String realmName,
                                          java.lang.String roleName)
                                          throws NoSuchRealmException,
                                                 BadRealmException,
                                                 NoSuchRoleException

  Deprecated. This method is not effective since Server V8, replaced by the method getJRole().

  Gets a role specified by roleName.

  Parameters:
    `submitter` - the user who requested this action.
    `realmName` - the realm name.
    `roleName` - the role name.
  Returns:
    a role that is requested.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchRoleException` - if the role does not exist.
  Since:
    V6

### getJRole

    JRole getJRole(java.lang.String submitter,
                   java.lang.String realmName,
                   java.lang.String roleName)
                   throws NoSuchRealmException,
                          BadRealmException,
                          NoSuchRoleException

  Gets a role specified by roleName.

  Parameters:
    `submitter` - the user who requested this action.
    `realmName` - the realm name.
    `roleName` - the role name.
  Returns:
    a role that is requested, return `null` if `submitter` is not an administrator user.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchRoleException` - if the role does not exist.
  Since:
    V8
  See Also:
    `JRole`

### getRoleMemberCount

    int getRoleMemberCount(java.lang.String realmName,
                           java.lang.String roleName)
                           throws NoSuchRealmException,
                                  BadRealmException,
                                  NoSuchRoleException

  Gets member count in a role.

  Parameters:
    `realmName` - the realm name.
    `roleName` - the role name.
  Returns:
    the member count in the specified role.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchRoleException` - if the role does not exist.
  Since:
    V6

### getRoleMemberCount

    int getRoleMemberCount(java.lang.String realmName,
                           java.lang.String submitter,
                           java.lang.String roleName)
                           throws NoSuchRealmException,
                                  BadRealmException,
                                  NoSuchRoleException

  Gets member count in a role.

  Parameters:
    `realmName` - the realm name.
    `submitter` - the submitter's name
    `roleName` - the role name.
  Returns:
    the member count in the specified role.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchRoleException` - if the role does not exist.
  Since:
    V6

### getSubRolesByRole

    java.util.Vector getSubRolesByRole(java.lang.String realmName,
                                       java.lang.String submitter,
                                       java.lang.String roleName)
                                       throws NoSuchRoleException,
                                              NoSuchRealmException,
                                              BadRealmException

  Deprecated. This method is not effective since Server V8, replaced by the method getSubJRolesByJRole().

  Gets the set of a role's sub roles.

  Parameters:
    `realmName` - the realm name.
    `submitter` - the submitter's name
    `roleName` - the role's name
  Returns:
    the sub roles' set
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchRoleException` - if the role does not exist.
  Since:
    V6

### getSubJRolesByJRole

    JRole[] getSubJRolesByJRole(java.lang.String realmName,
                                java.lang.String submitter,
                                java.lang.String roleName)
                                throws NoSuchRoleException,
                                       NoSuchRealmException,
                                       BadRealmException

  Gets the set of a role's sub roles.

  Parameters:
    `realmName` - the realm name.
    `submitter` - the submitter's name
    `roleName` - the role's name
  Returns:
    the sub roles' set
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchRoleException` - if the role does not exist.
  Since:
    V8
  See Also:
    `JRole`

### getSubUsersByRole

    java.util.Vector getSubUsersByRole(java.lang.String realmName,
                                       java.lang.String submitter,
                                       java.lang.String roleName)
                                       throws NoSuchRoleException,
                                              NoSuchRealmException,
                                              BadRealmException

  Deprecated. This method is not effective since Server V8, replaced by the method getSubJUsersByJRole().

  Gets the set of a role's sub users.

  Parameters:
    `realmName` - the realm name.
    `submitter` - the submitter's name
    `roleName` - the role's name
  Returns:
    the sub users' set
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchRoleException` - if the role does not exist.
  Since:
    V6

### getSubJUsersByJRole

    JUser[] getSubJUsersByJRole(java.lang.String realmName,
                                java.lang.String submitter,
                                java.lang.String roleName)
                                throws NoSuchRoleException,
                                       NoSuchRealmException,
                                       BadRealmException

  Gets the set of a role's sub users.

  Parameters:
    `realmName` - the realm name.
    `submitter` - the submitter's name
    `roleName` - the role's name
  Returns:
    the sub users' set
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchRoleException` - if the role does not exist.
  Since:
    V8
  See Also:
    `JUser`

### removeRoleFromParentRole

    java.lang.String removeRoleFromParentRole(java.lang.String submitter,
                                              java.lang.String realmName,
                                              java.lang.String roleName,
                                              java.lang.String parentRoleName)
                                              throws NoSuchRoleException,
                                                     NoSuchRealmException,
                                                     BadRealmException

  Removes a role from a parent role.

  Parameters:
    `submitter` - the submitter's name
    `realmName` - the realm name.
    `roleName` - the name of role that will be removed from a parent role.
    `parentRoleName` - the parent role's name
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchRoleException` - if the role does not exist.
  Since:
    V6

### removeUserFromParentRole

    java.lang.String removeUserFromParentRole(java.lang.String submitter,
                                              java.lang.String realmName,
                                              java.lang.String userName,
                                              java.lang.String parentRoleName)
                                              throws NoSuchRoleException,
                                                     NoSuchUserException,
                                                     NoSuchRealmException,
                                                     BadRealmException

  Removes a user from a parent role.

  Parameters:
    `submitter` - the submitter's name
    `realmName` - the realm name.
    `userName` - the name of user that will be removed from a parent role.
    `parentRoleName` - the parent role's name
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchRoleException` - if the role does not exist.
    `NoSuchUserException` - if the user does not exist.
  Since:
    V6

### getSubUsersNameByRole

    java.util.Vector getSubUsersNameByRole(java.lang.String realmName,
                                           java.lang.String submitter,
                                           java.lang.String roleName)
                                           throws NoSuchRoleException,
                                                  NoSuchRealmException,
                                                  BadRealmException

  Deprecated. This method is not effective since Server V8, replaced by the method getSubJUsersNameByJRole().

  Gets the set of a role's sub users' names.

  Parameters:
    `realmName` - the realm name.
    `submitter` - the submitter's name
    `roleName` - the role's name
  Returns:
    the sub users' names set
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchRoleException` - if the role does not exist.
  Since:
    V6

### addSubUserToRole

    java.lang.String addSubUserToRole(java.lang.String realmName,
                                      java.lang.String submitter,
                                      java.lang.String subUserName,
                                      java.lang.String roleName)
                                      throws NoSuchRoleException,
                                             NoSuchUserException,
                                             NoSuchRealmException,
                                             BadRealmException

  Adds a sub user to a role.

  Parameters:
    `realmName` - the realm name.
    `submitter` - the submitter's name
    `subUserName` - the sub user's name
    `roleName` - the role's name
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchUserException` - if the user does not exist.
    `NoSuchRoleException` - if the role does not exist.
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
  Since:
    V6

### addSubRoleToRole

    java.lang.String addSubRoleToRole(java.lang.String realmName,
                                      java.lang.String submitter,
                                      java.lang.String subRoleName,
                                      java.lang.String roleName)
                                      throws NoSuchRoleException,
                                             NoSuchRealmException,
                                             BadRealmException

  Adds a sub role to a role.

  Parameters:
    `realmName` - the realm name.
    `submitter` - the submitter's name
    `subRoleName` - the sub role's name
    `roleName` - the role's name
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchRoleException` - if the role does not exist.
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
  Since:
    V6

### getReferUsers

    java.util.Vector getReferUsers(java.lang.String realmName,
                                   java.lang.String userName)
                                   throws NoSuchUserException,
                                          NoSuchRealmException

  Deprecated. This method is not effective since Server V8, replaced by the method getReferJUsers().

  Returns referred users of the specified realm user.

  Parameters:
    `realmName` - the realm name.
    `userName` - the user name
  Returns:
    The names of the users that have same role or group as the user
  Throws:
    `NoSuchUserException` - if the user specified by userName not exist.
    `NoSuchRealmException` - if the realm specified by realmName does not exist.

### getReferRoles

    java.util.Vector getReferRoles(java.lang.String realmName,
                                   java.lang.String userName)
                                   throws NoSuchUserException,
                                          NoSuchRealmException

  Deprecated. This method is not effective since Server V8, replaced by the method getReferJRolers().

  Returns referred roles of the specified realm user.

  Parameters:
    `realmName` - the realm name
    `userName` - the user name
  Returns:
    The names of the roles that have some relationships with the user, for instance, all roles that belong to this user.
  Throws:
    `NoSuchUserException` - if the user specified by userName not exist.
    `NoSuchRealmException` - if the realm specified by realmName does not exist.

### isAdminUser

    boolean isAdminUser(java.lang.String userName)

  Checks if the user is administrator.

  Parameters:
    `userName` - the user's name
  Returns:
    if the user is administrator return true, otherwise return false

### setUserPrivileges

    void setUserPrivileges(java.lang.String userName,
                           java.util.Vector privileges)

  Deprecated. Server V7.1 replaced by `setUserPrivileges(String realmName, String submitter, String userName, Vector privileges) throws NoSuchUserException, NoSuchRealmException;`.

  Sets privileges to a user.

  Parameters:
    `userName` - the user name
    `privileges` - a Vector saving the available privileges such as APIConst.PRIVILEGE_PUBLISH_REPORT, APIConst.PRIVILEGE_ACCESS_ADVANCED_PROPERTIES

### setUserPrivileges

    java.lang.String setUserPrivileges(java.lang.String realmName,
                                       java.lang.String submitter,
                                       java.lang.String userName,
                                       java.util.Vector privileges)
                                       throws NoSuchUserException,
                                              NoSuchRealmException

  Sets privileges to a user.

  Parameters:
    `realmName` - the realm name
    `submitter` - the submitter name
    `userName` - the user's name
    `privileges` - a Vector saving the available privileges such as APIConst.PRIVILEGE_PUBLISH_REPORT, APIConst.PRIVILEGE_ACCESS_ADVANCED_PROPERTIES
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchUserException` - if the user does not exist.
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
  Since:
    Server V7.1

### setRolePrivileges

    void setRolePrivileges(java.lang.String roleName,
                           java.util.Vector privileges)

  Deprecated. Server V7.1 replaced by `setRolePrivileges(String realmName, String submitter, String roleName, Vector privileges) throws NoSuchRoleException, NoSuchRealmException;`.

  Sets privileges to a role.

  Parameters:
    `roleName` - the role name
    `privileges` - a Vector saving the available privileges such as APIConst.PRIVILEGE_PUBLISH_REPORT, APIConst.PRIVILEGE_ACCESS_ADVANCED_PROPERTIES

### setRolePrivileges

    java.lang.String setRolePrivileges(java.lang.String realmName,
                                       java.lang.String submitter,
                                       java.lang.String roleName,
                                       java.util.Vector privileges)
                                       throws NoSuchRoleException,
                                              NoSuchRealmException,
                                              BadRealmException

  Sets privileges to a role.

  Parameters:
    `realmName` - the realm's name
    `submitter` - the submitter's name
    `roleName` - the role name
    `privileges` - a Vector saving the available privileges such as APIConst.PRIVILEGE_PUBLISH_REPORT, APIConst.PRIVILEGE_ACCESS_ADVANCED_PROPERTIES
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchRoleException` - if the role does not exist.
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
  Since:
    Server V7.1

### setGroupPrivileges

    java.lang.String setGroupPrivileges(java.lang.String realmName,
                                        java.lang.String submitter,
                                        java.lang.String groupName,
                                        java.util.Vector privileges)
                                        throws NoSuchGroupException,
                                               NoSuchRealmException,
                                               BadRealmException

  Sets privileges to a group.

  Parameters:
    `realmName` - the realm's name
    `submitter` - the submitter's name
    `groupName` - the group name
    `privileges` - a Vector saving the available privileges such as APIConst.PRIVILEGE_PUBLISH_REPORT, APIConst.PRIVILEGE_ACCESS_ADVANCED_PROPERTIES
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchGroupException` - if the group does not exist.
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
  Since:
    Server V7.1

### getUserPrivileges

    java.util.Vector getUserPrivileges(java.lang.String userName)

  Deprecated. Server V7.1 replaced by `getUserPrivileges(String realmName, String submitter, String userName,) throws NoSuchUserException, NoSuchRealmException;`.

  Gets a user's privileges.

  Parameters:
    `userName` - the user name
  Returns:
    the user's privileges

### getUserPrivileges

    java.util.Vector getUserPrivileges(java.lang.String realmName,
                                       java.lang.String submitter,
                                       java.lang.String userName)
                                       throws NoSuchUserException,
                                              NoSuchRealmException

  Gets a user's privileges.

  Parameters:
    `realmName` - the realm's name
    `submitter` - the submitter's name
    `userName` - the user's name
  Throws:
    `NoSuchUserException` - if the user does not exist.
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
  Since:
    Server V7.1

### getRolePrivileges

    java.util.Vector getRolePrivileges(java.lang.String roleName)

  Deprecated. Server V7.1 replaced by `getRolePrivileges(String realmName, String submitter, String roleName,) throws NoSuchRoleException, NoSuchRealmException;`.

  Gets a role's privileges.

  Parameters:
    `roleName` - the role name
  Returns:
    the role's privileges

### getRolePrivileges

    java.util.Vector getRolePrivileges(java.lang.String realmName,
                                       java.lang.String submitter,
                                       java.lang.String roleName)
                                       throws NoSuchRoleException,
                                              NoSuchRealmException,
                                              BadRealmException

  Gets a role's privileges.

  Parameters:
    `realmName` - the realm's name
    `submitter` - the submitter's name
    `roleName` - the role's name
  Returns:
    the role's privileges
  Throws:
    `NoSuchRoleException` - if the role does not exist.
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
  Since:
    Server V7.1

### getGroupPrivileges

    java.util.Vector getGroupPrivileges(java.lang.String realmName,
                                        java.lang.String submitter,
                                        java.lang.String groupName)
                                        throws NoSuchGroupException,
                                               NoSuchRealmException,
                                               BadRealmException

  Gets a group's privileges.

  Parameters:
    `realmName` - the realm's name
    `submitter` - the submitter's name
    `groupName` - the group's name
  Returns:
    the group's privileges
  Throws:
    `NoSuchGroupException` - if the group does not exist.
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
  Since:
    Server V7.1

### getPrivileges

    java.util.Hashtable[] getPrivileges(java.lang.String realmName,
                                        java.lang.String submitter)
                                        throws NoSuchGroupException,
                                               NoSuchRealmException,
                                               BadRealmException

  Gets defined privileges of users.

  Parameters:
    `realmName` - the realm's name
    `submitter` - the submitter's name
  Returns:
    a `Hashtable` array, which contains three `Hashtable` objects. The first `Hashtable` contains several user/privileges pairs to represent defined privileges. In this `Hashtable` object, the key is user name, the value is a `Vector` object which contains all privileges The second `Hashtable` object contains several role/privileges pairs to represent defined privileges and its structure is similar to user/privileges. The third `Hashtable` object contains several group/privileges pairs to represent defined privileges and its structure is similar to user/privileges. Or null if the user/role/group does not have permission to get privileges.
  Throws:
    `NoSuchGroupException` - if the group does not exist.
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.

### setPrivileges

    void setPrivileges(java.lang.String realmName,
                       java.lang.String submitter,
                       java.util.Hashtable[] privileges)
                       throws NoSuchUserException,
                              NoSuchRealmException

  Sets privileges of users.

  Parameters:
    `realmName` - the realm's name
    `submitter` - the submitter's name
    `privileges` - a `Hashtable` array, which may contain three `Hashtable` objects. The first `Hashtable` contains several user/privileges pairs to represent privileges. In this `Hashtable` object, the key is user name, the value is a `Vector` object which contains all privileges The second `Hashtable` object contains several role/privileges pairs to represent defined privileges and its structure is similar to user/privileges The third `Hashtable` object contains several group/privileges pairs to represent defined privileges and its structure is similar to user/privileges The structure of Hashtable[] privileges is: ::= ::= NULL | {, }... ::= NULL | {, }... ::= NULL | {, }... ::= a string of user name ::= a string of role name ::= a string of group name ::= | { | }... ::= a vector object containing nothing ::= String APIConst.PRIVILEGE_PUBLISH_REPORT ::= String APIConst.PRIVILEGE_ACCESS_ADVANCED_PROPERTIES
  Throws:
    `NoSuchUserException` - if the user does not exist.
    `NoSuchRealmException` - if the realm specified by realmName does not exist.

### getPrivilegedUsers

    java.util.Vector getPrivilegedUsers(java.lang.String privilege)

  Deprecated. Server V7.1 replaced by `getPrivilegedUsers(String realmName, String submitter, String privilege,) throws NoSuchRealmException;`.

  Gets all users who have the privilege.

  Parameters:
    `privilege` - a String saving the available privilege such as APIConst.PRIVILEGE_PUBLISH_REPORT, APIConst.PRIVILEGE_ACCESS_ADVANCED_PROPERTIES
  Returns:
    users a Vector saving the users' names

### getPrivilegedUsers

    java.util.Vector getPrivilegedUsers(java.lang.String realmName,
                                        java.lang.String submitter,
                                        java.lang.String privilege)
                                        throws NoSuchRealmException

  Gets all users who have the privilege.

  Parameters:
    `realmName` - the realm's name
    `submitter` - the submitter's name
    `privilege` - a String saving the available privilege such as APIConst.PRIVILEGE_PUBLISH_REPORT, APIConst.PRIVILEGE_ACCESS_ADVANCED_PROPERTIES
  Returns:
    users a Vector saving the users' names
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
  Since:
    Server V7.1

### getPrivilegedRoles

    java.util.Vector getPrivilegedRoles(java.lang.String privilege)

  Deprecated. Server V7.1 replaced by `getPrivilegedRoles(String realmName, String submitter, String privilege,) throws NoSuchRealmException;`.

  Gets all roles who have the privilege.

  Parameters:
    `privilege` - a String saving the available privilege such as APIConst.PRIVILEGE_PUBLISH_REPORT, APIConst.PRIVILEGE_ACCESS_ADVANCED_PROPERTIES
  Returns:
    roles a Vector saving the roles' names

### getPrivilegedRoles

    java.util.Vector getPrivilegedRoles(java.lang.String realmName,
                                        java.lang.String submitter,
                                        java.lang.String privilege)
                                        throws NoSuchRealmException

  Gets all roles who have the privilege.

  Parameters:
    `realmName` - the realm's name
    `submitter` - the submitter's name
    `privilege` - a String saving the available privilege such as APIConst.PRIVILEGE_PUBLISH_REPORT, APIConst.PRIVILEGE_ACCESS_ADVANCED_PROPERTIES
  Returns:
    roles a Vector saving the roles' names
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
  Since:
    Server V7.1

### getPrivilegedGroups

    java.util.Vector getPrivilegedGroups(java.lang.String realmName,
                                         java.lang.String submitter,
                                         java.lang.String privilege)
                                         throws NoSuchRealmException

  Gets all groups who have the privilege.

  Parameters:
    `realmName` - the realm's name
    `submitter` - the submitter's name
    `privilege` - a String saving the available privilege such as APIConst.PRIVILEGE_PUBLISH_REPORT, APIConst.PRIVILEGE_ACCESS_ADVANCED_PROPERTIES
  Returns:
    groups a Vector saving the groups' names
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
  Since:
    Server V7.1

### addPrivilegedUsers

    void addPrivilegedUsers(java.lang.String privilege,
                            java.util.Vector users)

  Deprecated. Server V7.1 replaced by `addPrivilegedUsers(String realmName, String submitter, String privilege, Vector users) throws NoSuchUserException, NoSuchRealmException;`.

  Adds users to have this privilege.

  Parameters:
    `privilege` - a String saving the available privilege such as APIConst.PRIVILEGE_PUBLISH_REPORT, APIConst.PRIVILEGE_ACCESS_ADVANCED_PROPERTIES
    `users` - a Vector saving the users' names

### addPrivilegedUsers

    java.lang.String addPrivilegedUsers(java.lang.String realmName,
                                        java.lang.String submitter,
                                        java.lang.String privilege,
                                        java.util.Vector users)
                                        throws NoSuchUserException,
                                               NoSuchRealmException

  Adds users to have this privilege.

  Parameters:
    `realmName` - the realm's name
    `submitter` - the submitter's name
    `privilege` - a String saving the available privilege such as APIConst.PRIVILEGE_PUBLISH_REPORT, APIConst.PRIVILEGE_ACCESS_ADVANCED_PROPERTIES
    `users` - a Vector saving the users' names
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchUserException` - if the user specified by users does not exist.
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
  Since:
    Server V7.1

### addPrivilegedRoles

    void addPrivilegedRoles(java.lang.String privilege,
                            java.util.Vector roles)

  Deprecated. Server V7.1 replaced by `addPrivilegedRoles(String realmName, String submitter, String privilege, Vector groups) throws NoSuchGroupException, NoSuchRealmException, BadRealmException;`.

  Adds roles to have this privilege.

  Parameters:
    `privilege` - a String saving the available privilege such as APIConst.PRIVILEGE_PUBLISH_REPORT, APIConst.PRIVILEGE_ACCESS_ADVANCED_PROPERTIES
    `roles` - a Vector saving the roles' names

### addPrivilegedRoles

    java.lang.String addPrivilegedRoles(java.lang.String realmName,
                                        java.lang.String submitter,
                                        java.lang.String privilege,
                                        java.util.Vector roles)
                                        throws NoSuchRoleException,
                                               NoSuchRealmException,
                                               BadRealmException

  Adds roles to have this privilege.

  Parameters:
    `realmName` - the realm's name
    `submitter` - the submitter's name
    `privilege` - a String saving the available privilege such as APIConst.PRIVILEGE_PUBLISH_REPORT, APIConst.PRIVILEGE_ACCESS_ADVANCED_PROPERTIES
    `roles` - a Vector saving the roles' names
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchRoleException` - if the role specified by roles does not exist.
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
  Since:
    Server V7.1

### addPrivilegedGroups

    java.lang.String addPrivilegedGroups(java.lang.String realmName,
                                         java.lang.String submitter,
                                         java.lang.String privilege,
                                         java.util.Vector groups)
                                         throws NoSuchGroupException,
                                                NoSuchRealmException,
                                                BadRealmException

  Adds roles to have this privilege.

  Parameters:
    `realmName` - the realm's name
    `submitter` - the submitter's name
    `privilege` - a String saving the available privilege such as APIConst.PRIVILEGE_PUBLISH_REPORT, APIConst.PRIVILEGE_ACCESS_ADVANCED_PROPERTIES
    `groups` - a Vector saving the groups' names
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchGroupException` - if the group specified by groups does not exist.
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
  Since:
    Server V7.1

### removePrivilegedUsers

    java.lang.String removePrivilegedUsers(java.lang.String privilege,
                                           java.util.Vector users)

  Deprecated. Server V7.1 replaced by `removePrivilegedUsers(String realmName, String submitter, String privilege, Vector users) throws NoSuchUserException, NoSuchRealmException;`.

  Removes users from having the privilege.

  Parameters:
    `privilege` - a String saving the available privilege such as APIConst.PRIVILEGE_PUBLISH_REPORT, APIConst.PRIVILEGE_ACCESS_ADVANCED_PROPERTIES
    `users` - a Vector saving the users' names
  Returns:
    message if successful return null, or else return error message

### removePrivilegedUsers

    java.lang.String removePrivilegedUsers(java.lang.String realmName,
                                           java.lang.String submitter,
                                           java.lang.String privilege,
                                           java.util.Vector users)
                                           throws NoSuchUserException,
                                                  NoSuchRealmException

  Removes users from having the privilege.

  Parameters:
    `realmName` - the realm's name
    `submitter` - the submitter's name
    `privilege` - a String saving the available privilege such as APIConst.PRIVILEGE_PUBLISH_REPORT, APIConst.PRIVILEGE_ACCESS_ADVANCED_PROPERTIES
    `users` - a Vector saving the users' names
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchUserException` - if the user specified by users does not exist.
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
  Since:
    Server V7.1

### removePrivilegedRoles

    java.lang.String removePrivilegedRoles(java.lang.String privilege,
                                           java.util.Vector roles)

  Deprecated. Server V7.1 replaced by `removePrivilegedRoles(String realmName, String submitter, String privilege, Vector roles) throws NoSuchRoleException, NoSuchRealmException;`.

  Removes roles from having the privilege.

  Parameters:
    `privilege` - a String saving the available privilege such as APIConst.PRIVILEGE_PUBLISH_REPORT, APIConst.PRIVILEGE_ACCESS_ADVANCED_PROPERTIES
    `roles` - a Vector saving the roles' names
  Returns:
    message if successful return null, or else return error message

### removePrivilegedRoles

    java.lang.String removePrivilegedRoles(java.lang.String realmName,
                                           java.lang.String submitter,
                                           java.lang.String privilege,
                                           java.util.Vector roles)
                                           throws NoSuchRoleException,
                                                  NoSuchRealmException,
                                                  BadRealmException

  Removes roles from having the privilege.

  Parameters:
    `realmName` - the realm's name
    `submitter` - the submitter's name
    `privilege` - a String saving the available privilege such as APIConst.PRIVILEGE_PUBLISH_REPORT, APIConst.PRIVILEGE_ACCESS_ADVANCED_PROPERTIES
    `roles` - a Vector saving the roles' names
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchRoleException` - if the role specified by roles does not exist.
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
  Since:
    Server V7.1

### removePrivilegedGroups

    java.lang.String removePrivilegedGroups(java.lang.String realmName,
                                            java.lang.String submitter,
                                            java.lang.String privilege,
                                            java.util.Vector groups)
                                            throws NoSuchGroupException,
                                                   NoSuchRealmException,
                                                   BadRealmException

  Removes groups from having the privilege.

  Parameters:
    `realmName` - the realm's name
    `submitter` - the submitter's name
    `privilege` - a String saving the available privilege such as APIConst.PRIVILEGE_PUBLISH_REPORT, APIConst.PRIVILEGE_ACCESS_ADVANCED_PROPERTIES
    `groups` - a Vector saving the groups' names
  Returns:
    error message if any error occurs but no exception is thrown, or null if successful.
  Throws:
    `NoSuchGroupException` - if the group specified by groups does not exist.
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
  Since:
    Server V7.1

### isEditing

    boolean isEditing(java.lang.String realm,
                      int action)
                      throws NoSuchRealmException

  Checks if the action can be edited.

  Parameters:
    `realm` - the realm's name
    `action` - the server security web UI's action:
  Returns:
    if able to do this action return true, otherwise return false
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
  Since:
    Server V8
  See Also:
    `SecurityWebAdaptor`

### isJUserInJRole

    boolean isJUserInJRole(java.lang.String realmName,
                           java.lang.String submitter,
                           java.lang.String userName,
                           java.lang.String roleName)
                           throws NoSuchUserException,
                                  NoSuchRoleException,
                                  NoSuchRealmException,
                                  NoSuchGroupException,
                                  BadRealmException

  Indicates whether the user is in a role.

  Parameters:
    `realmName` - the realm name
    `submitter` - the user who requested this action.
    `userName` - the user name
    `roleName` - the role name
  Returns:
    whether the user is in a role
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchUserException` - if the user does not exist.
    `NoSuchRoleException` - if the role does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchGroupException`
  Since:
    Server V8.3

### isJUserInJGroup

    boolean isJUserInJGroup(java.lang.String realmName,
                            java.lang.String submitter,
                            java.lang.String userName,
                            java.lang.String groupName)
                            throws NoSuchUserException,
                                   NoSuchGroupException,
                                   NoSuchRealmException,
                                   NoSuchRoleException,
                                   BadRealmException

  Indicates whether the user is in a group.

  Parameters:
    `realmName` - the realm name
    `submitter` - the user who requested this action.
    `userName` - the user name
    `groupName` - the group name
  Returns:
    whether the user is in a group
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchUserException` - if the user does not exist.
    `NoSuchGroupException` - if the group does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchRoleException`
  Since:
    Server V8.3

### isJGroupInJRole

    boolean isJGroupInJRole(java.lang.String realmName,
                            java.lang.String submitter,
                            java.lang.String groupName,
                            java.lang.String roleName)
                            throws NoSuchRoleException,
                                   NoSuchGroupException,
                                   NoSuchRealmException,
                                   BadRealmException

  Indicates whether the group is in a role.

  Parameters:
    `realmName` - the realm name
    `submitter` - the user who requested this action.
    `groupName` - the group name
    `roleName` - the role name
  Returns:
    whether the group is in a role
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchGroupException` - if the group does not exist.
    `NoSuchRoleException` - if the role does not exist.
  Since:
    Server V8.3

### isJGroupInJGroup

    boolean isJGroupInJGroup(java.lang.String realmName,
                             java.lang.String submitter,
                             java.lang.String groupName,
                             java.lang.String parentName)
                             throws NoSuchGroupException,
                                    NoSuchRealmException,
                                    BadRealmException

  Indicates whether the group is in a parent group.

  Parameters:
    `realmName` - the realm name
    `submitter` - the user who requested this action.
    `groupName` - the group name
    `parentName` - the parent group name
  Returns:
    whether the group is in a parent group
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchGroupException` - if the group does not exist.
  Since:
    Server V8.3

### isJRoleInJRole

    boolean isJRoleInJRole(java.lang.String realmName,
                           java.lang.String submitter,
                           java.lang.String roleName,
                           java.lang.String parentName)
                           throws NoSuchRoleException,
                                  NoSuchRealmException,
                                  BadRealmException

  Indicates whether the role is in a parent role.

  Parameters:
    `realmName` - the realm name
    `submitter` - the user who requested this action.
    `groupName` - the role name
    `parentName` - the parent role name
  Returns:
    whether the role is in a parent role
  Throws:
    `NoSuchRealmException` - if the realm specified by realmName does not exist.
    `BadRealmException` - if the specified realm data structures are bad.
    `NoSuchRoleException` - if the role does not exist.
  Since:
    Server V8.3

### isOrganizationAdminUser

    boolean isOrganizationAdminUser(java.lang.String userName)

  Checks if the user is administrator of a organization.

  Parameters:
    `userName` - the user's name
  Returns:
    if the user is administrator of a organization return true, otherwise return false

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD